package physapps.electrodynamics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class VectorFieldDiagram extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new VectorFieldDiagram(), 580, 380);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    parsedVectorField1 = new physbeans.phys.ParsedVectorField();
    parsedVectorField2 = new physbeans.phys.ParsedVectorField();
    parsedVectorField3 = new physbeans.phys.ParsedVectorField();
    parsedVectorField4 = new physbeans.phys.ParsedVectorField();
    parsedVectorField5 = new physbeans.phys.ParsedVectorField();
    parsedVectorField6 = new physbeans.phys.ParsedVectorField();
    objectSwitch1 = new physbeans.func.ObjectSwitch();
    vectorFieldView1 = new physbeans.views.VectorFieldView();
    imageView1 = new physbeans.views.ImageView();
    vectorSwitch1 = new physbeans.func.VectorSwitch();
    cart2PolarFunction1 = new physbeans.func.Cart2PolarFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    inputPanel1 = new physbeans.inout.InputPanel();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    switchBox1 = new physbeans.inout.SwitchBox();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    numericTextField3 = new physbeans.inout.NumericTextField();
    
    parsedVectorField1.setFunction(new String[] {"0.075*x1/(r*r*r); r: sqrt(x1*x1 + x2*x2)", "0.075*x2/(r*r*r); r: sqrt(x1*x1 + x2*x2)"});
    parsedVectorField1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorField1ValueChanged(evt);
      }
    });
    
    parsedVectorField2.setFunction(new String[] {"-0.2*x2/(r*r); r: sqrt(x1*x1 + x2*x2)", "0.2*x1/(r*r); r: sqrt(x1*x1 + x2*x2)"});
    parsedVectorField2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorField2ValueChanged(evt);
      }
    });
    
    parsedVectorField3.setFunction(new String[] {"0.0", "sin(pi*x1)"});
    parsedVectorField3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorField3ValueChanged(evt);
      }
    });
    
    parsedVectorField4.setFunction(new String[] {"sin(pi*x1 - 3.0)", "0.0"});
    parsedVectorField4.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorField4ValueChanged(evt);
      }
    });
    
    parsedVectorField5.setFunction(new String[] {"0.8*sin(phi); phi: 0.3*sin(pi*x1)", "-0.8*cos(phi); phi: 0.3*sin(pi*x1)"});
    parsedVectorField5.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorField5ValueChanged(evt);
      }
    });
    
    parsedVectorField6.setFunction(new String[] {"0.8", "0.6"});
    parsedVectorField6.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorField6ValueChanged(evt);
      }
    });
    
    objectSwitch1.setAllObjects(new Object[] {parsedVectorField1,parsedVectorField2,parsedVectorField3,parsedVectorField4,parsedVectorField5,parsedVectorField6}
    );
    objectSwitch1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        objectSwitch1SourceChanged(evt);
      }
    });
    
    vectorFieldView1.setNGridX(8);
    vectorFieldView1.setNGridY(6);
    vectorFieldView1.setMaxArrowLength(1.0);
    vectorFieldView1.setModel(parsedVectorField1);
    vectorFieldView1.setVectorScale(0.25);
    imageView1.setDepth(60);
    imageView1.setInfiniteScale(true);
    imageView1.setModel(parsedVectorField1);
    imageView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        imageView1SourceChanged(evt);
      }
    });
    
    vectorSwitch1.setNInput(6);
    vectorSwitch1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        vectorSwitch1ValueChanged(evt);
      }
    });
    
    cart2PolarFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        cart2PolarFunction1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel4.setLayout(new java.awt.BorderLayout());
    
    objectPanel1.setBordered(true);
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 200));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setViewActive(new boolean[]{true,true});
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel4.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new java.awt.BorderLayout());
    
    inputPanel1.setAlignmentX(0.5F);
    radioButtonBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s4"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s5"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s6"),
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s1")
    });
    radioButtonBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s8"));
    radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(radioButtonBox1, java.awt.BorderLayout.CENTER);
    
    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.electrodynamics.VectorFieldDiagram", currentLocale).getString("s7")
    });
    switchBox1.setSelected(new boolean[]{true});
    switchBox1.setTitle("");
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1, java.awt.BorderLayout.SOUTH);
    
    jPanel4.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    jPanel1.add(jPanel4, java.awt.BorderLayout.CENTER);
    
    outputPanel1.setBordered(true);
    vectorTextField1.setBordered(true);
    vectorTextField1.setColumns(6);
    vectorTextField1.setDescription(new String[] {"Vx =", "Vy ="});
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setUnit(new String[] {"", ""});
    outputPanel1.add(vectorTextField1);
    
    numericTextField3.setBordered(true);
    numericTextField3.setColumns(6);
    numericTextField3.setDescription("|V| =");
    numericTextField3.setEditable(false);
    numericTextField3.setUnit("");
    outputPanel1.add(numericTextField3);
    
    jPanel1.add(outputPanel1, java.awt.BorderLayout.SOUTH);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void imageView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_imageView1SourceChanged
    layeredScreen1.addView(imageView1);
    layeredScreen1.addView(vectorFieldView1);
  }//GEN-LAST:event_imageView1SourceChanged
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    DVector v = layeredScreen1.getClickedPosition();
    ((VectorField) objectSwitch1.getActiveObject()).sendVectorValue(v);
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(0, switchBox1.getSelected(0));
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    int index = radioButtonBox1.getSelected();
    objectSwitch1.setSelectedInput(index);
    vectorSwitch1.setSelectedInput(index);
  }//GEN-LAST:event_radioButtonBox1ValueChanged
  
  private void vectorSwitch1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_vectorSwitch1ValueChanged
    DVector v = vectorSwitch1.getOutputVector();
    vectorTextField1.setValue(v);
    cart2PolarFunction1.setInputVector(v);
  }//GEN-LAST:event_vectorSwitch1ValueChanged
  
  private void parsedVectorField6ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorField6ValueChanged
    vectorSwitch1.setInputVector(5, parsedVectorField6.getLastVectorValue());
  }//GEN-LAST:event_parsedVectorField6ValueChanged
  
  private void parsedVectorField5ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorField5ValueChanged
    vectorSwitch1.setInputVector(4, parsedVectorField5.getLastVectorValue());
  }//GEN-LAST:event_parsedVectorField5ValueChanged
  
  private void parsedVectorField4ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorField4ValueChanged
    vectorSwitch1.setInputVector(3, parsedVectorField4.getLastVectorValue());
  }//GEN-LAST:event_parsedVectorField4ValueChanged
  
  private void parsedVectorField3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorField3ValueChanged
    vectorSwitch1.setInputVector(2, parsedVectorField3.getLastVectorValue());
  }//GEN-LAST:event_parsedVectorField3ValueChanged
  
  private void parsedVectorField2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorField2ValueChanged
    vectorSwitch1.setInputVector(1, parsedVectorField2.getLastVectorValue());
  }//GEN-LAST:event_parsedVectorField2ValueChanged
  
  private void parsedVectorField1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorField1ValueChanged
    vectorSwitch1.setInputVector(0, parsedVectorField1.getLastVectorValue());
  }//GEN-LAST:event_parsedVectorField1ValueChanged
  
  private void objectSwitch1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_objectSwitch1SourceChanged
    VectorField field = (VectorField) objectSwitch1.getActiveObject();
    vectorFieldView1.setModel(field);
    imageView1.setModel(field);
  }//GEN-LAST:event_objectSwitch1SourceChanged
  
  private void cart2PolarFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_cart2PolarFunction1ValueChanged
    numericTextField3.setValue(cart2PolarFunction1.getOutputVector().get(0));
  }//GEN-LAST:event_cart2PolarFunction1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.Cart2PolarFunction cart2PolarFunction1;
  protected physbeans.views.ImageView imageView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel4;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.NumericTextField numericTextField3;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.func.ObjectSwitch objectSwitch1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.ParsedVectorField parsedVectorField1;
  protected physbeans.phys.ParsedVectorField parsedVectorField2;
  protected physbeans.phys.ParsedVectorField parsedVectorField3;
  protected physbeans.phys.ParsedVectorField parsedVectorField4;
  protected physbeans.phys.ParsedVectorField parsedVectorField5;
  protected physbeans.phys.ParsedVectorField parsedVectorField6;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.views.VectorFieldView vectorFieldView1;
  protected physbeans.func.VectorSwitch vectorSwitch1;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
