package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class Lissajous extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new Lissajous(), 610, 465);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    harmonicVectorFunction2 = new physbeans.func.HarmonicFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    arithmeticFunction2 = new physbeans.func.ArithmeticFunction();
    arithmeticFunction3 = new physbeans.func.ArithmeticFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    xYScope1 = new physbeans.inout.XYScope();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    numericTextField2 = new physbeans.inout.NumericTextField();
    numericTextField3 = new physbeans.inout.NumericTextField();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    
    harmonicVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction1ValueChanged(evt);
      }
    });
    
    harmonicVectorFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction2ValueChanged(evt);
      }
    });
    
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    arithmeticFunction2.setFirstOp(3);
    arithmeticFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction2ValueChanged(evt);
      }
    });
    
    arithmeticFunction3.setFirstOp(1);
    arithmeticFunction3.setSecondOp(3);
    arithmeticFunction3.setThirdArg(3.1415926);
    arithmeticFunction3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction3ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());
    
    jPanel2.setFont(standardFont);
    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(1.1);
    xYScope1.setMaxY(1.1);
    xYScope1.setMinX(-1.1);
    xYScope1.setMinY(-1.1);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.Lissajous", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.Lissajous", currentLocale).getString("osciScale"));
    xYScope1.setScaleX(true);
    xYScope1.setShowMarker(true);
    objectPanel1.add(xYScope1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    numericTextField1.setBordered(true);
    numericTextField1.setColumns(4);
    numericTextField1.setDescription("Ax/Ay =");
    numericTextField1.setEditable(false);
    numericTextField1.setUnit("");
    outputPanel1.add(numericTextField1);
    
    numericTextField2.setBordered(true);
    numericTextField2.setColumns(4);
    numericTextField2.setDescription("\u03c9x/\u03c9y =");
    numericTextField2.setEditable(false);
    numericTextField2.setUnit("");
    outputPanel1.add(numericTextField2);
    
    numericTextField3.setBordered(true);
    numericTextField3.setColumns(4);
    numericTextField3.setDescription("\u03c6x - \u03c6y =");
    numericTextField3.setEditable(false);
    numericTextField3.setUnit("* \u03c0");
    outputPanel1.add(numericTextField3);
    
    jPanel2.add(outputPanel1, java.awt.BorderLayout.SOUTH);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(8L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.Lissajous", currentLocale).getString("timerLabel"));
    timer1.setTimeIncrement(0.02);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("Ax =");
    textSlider1.setModel(new BoundedRealModel(0.0,0.5,1.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("\u03c9x =");
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(0.1,0.9999925277988236,5.0));
    textSlider2.setUnit("1/s");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03c6x =");
    textSlider3.setModel(new BoundedRealModel(-1.0,-0.5,1.0));
    textSlider3.setUnit("* \u03c0");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("Ay =");
    textSlider4.setModel(new BoundedRealModel(0.0,0.5,1.0));
    textSlider4.setUnit("m");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("\u03c9y =");
    textSlider5.setLogarithmic(true);
    textSlider5.setModel(new BoundedRealModel(0.1,1.5000129063185785,5.0));
    textSlider5.setUnit("1/s");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    textSlider6.setDescription("\u03c6y =");
    textSlider6.setModel(new BoundedRealModel(-1.0,-0.5,1.0));
    textSlider6.setUnit("* \u03c0");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider6);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    xYScope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart

  private void harmonicVectorFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction2ValueChanged
    multiplexer1.setInputValues(1, harmonicVectorFunction2.getOutputValue());
  }//GEN-LAST:event_harmonicVectorFunction2ValueChanged

  private void harmonicVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction1ValueChanged
    multiplexer1.setInputValues(0, harmonicVectorFunction1.getOutputValue());
  }//GEN-LAST:event_harmonicVectorFunction1ValueChanged
        
  private void arithmeticFunction3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction3ValueChanged
    numericTextField3.setValue(arithmeticFunction3.getResult());
  }//GEN-LAST:event_arithmeticFunction3ValueChanged
  
  private void arithmeticFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction2ValueChanged
    numericTextField1.setValue(arithmeticFunction2.getResult());
  }//GEN-LAST:event_arithmeticFunction2ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    numericTextField2.setValue(arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    double val = textSlider6.getValue()*Math.PI;
    harmonicVectorFunction2.setAlpha(val);
    arithmeticFunction3.setSecondArg(val);
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    harmonicVectorFunction2.setOmega(textSlider5.getValue());
    arithmeticFunction1.setSecondArg(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    harmonicVectorFunction2.setAmplitude(textSlider4.getValue());
    arithmeticFunction2.setSecondArg(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue()*Math.PI;
    harmonicVectorFunction1.setAlpha(val);
    arithmeticFunction3.setFirstArg(val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    harmonicVectorFunction1.setOmega(textSlider2.getValue());
    arithmeticFunction1.setFirstArg(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    harmonicVectorFunction1.setAmplitude(textSlider1.getValue());
    arithmeticFunction2.setFirstArg(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
    
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    harmonicVectorFunction1.setInputValue(timer1.getTime());
    harmonicVectorFunction2.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.ArithmeticFunction arithmeticFunction2;
  protected physbeans.func.ArithmeticFunction arithmeticFunction3;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction2;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.NumericTextField numericTextField2;
  protected physbeans.inout.NumericTextField numericTextField3;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
// End of variables declaration//GEN-END:variables
  
}
