package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class LongChain extends PhysBeansApplet {
    
    static public void main(String[] args) {
        startApp(new LongChain(), 800, 600);
    }
    
    /** Creates new form Simulation */
    public void init() {
        setLocale();
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    linearChainOscillator1 = new physbeans.phys.LinearChainOscillator();
    springChainView1 = new physbeans.views.SpringChainView();
    selector1 = new physbeans.func.Selector();
    constantVector1 = new physbeans.func.ConstantVector();
    constantVector2 = new physbeans.func.ConstantVector();
    vectorSwitch1 = new physbeans.func.VectorSwitch();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSlider1 = new physbeans.inout.VectorSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    switchBox2 = new physbeans.inout.SwitchBox();

    linearChainOscillator1.setDamperCoefficients(DVector.valueOf("[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    linearChainOscillator1.setMasses(DVector.valueOf("[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]"));
    linearChainOscillator1.setSpringStiffnesses(DVector.valueOf("[0.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]"));
    linearChainOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        linearChainOscillator1ValueChanged1(evt);
        linearChainOscillator1ValueChanged(evt);
      }
    });

    springChainView1.setXScale(1.0);
    springChainView1.setHideHugeSprings(true);
    springChainView1.setSpringScale(0.5);
    springChainView1.setSystem(linearChainOscillator1);
    springChainView1.setTransversal(true);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });

    selector1.setIndex(new int[]{0,19});
    selector1.setInputLength(20);
    selector1.setOutputLength(2);
    selector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selector1ValueChanged(evt);
      }
    });

    constantVector1.setVector(DVector.valueOf("[0.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,0.0]"));
    constantVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        constantVector1ValueChanged(evt);
      }
    });

    constantVector2.setVector(DVector.valueOf("[0.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0]"));
    constantVector2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        constantVector2ValueChanged(evt);
      }
    });

    vectorSwitch1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        vectorSwitch1ValueChanged(evt);
      }
    });

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    jPanel2.setFont(standardFont);
    objectPanel.setLayout(new java.awt.BorderLayout());

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(21.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.X_AXIS));

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(300, 142));
    oscilloscope1.setLineActive(new boolean[]{true,true});
    oscilloscope1.setMaxY(3.5);
    oscilloscope1.setMinY(-3.5);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongChain", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongChain", currentLocale).getString("osciScale"));
    outputPanel.add(oscilloscope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    timer1.setDelay(20L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongChain", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });

    inputPanel.add(timer1);

    vectorSlider1.setCount(20);
    vectorSlider1.setDescription(" x0 =");
    vectorSlider1.setInitialValues(DVector.valueOf("[3.0,2.7716,2.1213,1.1481,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]"));
    vectorSlider1.setMaximum(3.0);
    vectorSlider1.setMinimum(-3.0);
    vectorSlider1.setUnit("m");
    vectorSlider1.setVertical(false);
    vectorSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider1PropertyChange(evt);
        vectorSlider1PropertyChange1(evt);
      }
    });

    inputPanel.add(vectorSlider1);

    switchBox1.setBoxLabel(new String[] {"x1", "x20"});
    switchBox1.setSelected(new boolean[]{true,true});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps/linearoscillations/LongChain").getString("s1"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });

    inputPanel.add(switchBox1);

    switchBox2.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.LongChain", currentLocale).getString("s2")
    });
    switchBox2.setSelected(new boolean[]{true});
    switchBox2.setTitle("");
    switchBox2.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox2ValueChanged(evt);
        switchBox2ValueChanged1(evt);
        switchBox2ValueChanged2(evt);
      }
    });

    inputPanel.add(switchBox2);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents

  private void switchBox2ValueChanged2(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged2
    constantVector2.trigger();
  }//GEN-LAST:event_switchBox2ValueChanged2

  private void switchBox2ValueChanged1(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged1
    constantVector1.trigger();
  }//GEN-LAST:event_switchBox2ValueChanged1

  private void constantVector2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_constantVector2ValueChanged
    vectorSwitch1.setInputVector(1, constantVector2.getOutputVector());
  }//GEN-LAST:event_constantVector2ValueChanged

  private void constantVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_constantVector1ValueChanged
    vectorSwitch1.setInputVector(0, constantVector1.getOutputVector());
  }//GEN-LAST:event_constantVector1ValueChanged

  private void vectorSwitch1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_vectorSwitch1ValueChanged
    linearChainOscillator1.setSpringStiffnesses(vectorSwitch1.getOutputVector());
  }//GEN-LAST:event_vectorSwitch1ValueChanged

  private void switchBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged
    vectorSwitch1.setSelectedInput(switchBox2.getFirstSelectedAsInt());
  }//GEN-LAST:event_switchBox2ValueChanged

    private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
        oscilloscope1.setLineActive(switchBox1.getSelected());
    }//GEN-LAST:event_switchBox1ValueChanged
    
    private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
      oscilloscope1.setInputVector(selector1.getOutputVector());
    }//GEN-LAST:event_selector1ValueChanged
    
  private void linearChainOscillator1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged
      selector1.setInputVector(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged
  
  private void linearChainOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged1
      springChainView1.setDisplacements(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged1
  
  private void vectorSlider1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange1
      springChainView1.setInitialDisplacements(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange1
  
  private void vectorSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange
      linearChainOscillator1.setX0(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange
  
  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
      springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2
  
  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
      layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
      linearChainOscillator1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
      oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
      linearChainOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ConstantVector constantVector1;
  protected physbeans.func.ConstantVector constantVector2;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LinearChainOscillator linearChainOscillator1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.Selector selector1;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.SwitchBox switchBox2;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSlider1;
  protected physbeans.func.VectorSwitch vectorSwitch1;
  // End of variables declaration//GEN-END:variables
    
}
