package physapps.mathematics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class MonteCarloE extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new MonteCarloE(), 440, 450);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    normalRandomVector1 = new physbeans.func.NormalRandomVector();
    normalRandomVector2 = new physbeans.func.NormalRandomVector();
    parsedVectorFunction1 = new physbeans.func.ParsedVectorFunction();
    sumFunction1 = new physbeans.func.SumFunction();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    pointView1 = new physbeans.views.PointView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel = new physbeans.inout.PhysicsPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    numericTextField2 = new physbeans.inout.NumericTextField();
    
    normalRandomVector1.setRandomize(true);
    normalRandomVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        normalRandomVector1ValueChanged(evt);
      }
    });
    
    normalRandomVector2.setRandomize(true);
    normalRandomVector2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        normalRandomVector2ValueChanged(evt);
      }
    });
    
    parsedVectorFunction1.setFunction(new String[] {"if(v1*v1+v2*v2 < 2.0, 1.0, 0.0)"});
    parsedVectorFunction1.setAutoTriggered(false);
    parsedVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedVectorFunction1ValueChanged(evt);
      }
    });
    
    sumFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        sumFunction1ValueChanged(evt);
      }
    });
    
    arithmeticFunction1.setAssociativity(4);
    arithmeticFunction1.setFirstArg(1.0);
    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.setSecondArg(1.0);
    arithmeticFunction1.setSecondOp(1);
    arithmeticFunction1.setThirdOp(3);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    pointView1.setDepth(60);
    pointView1.setPaintCross(false);
    pointView1.setPointRadius(0.02);
    pointView1.setUseTwoVectors(true);
    pointView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointView1SourceChanged(evt);
      }
    });
    
    simpleFigureView1.setFigureType(7);
    simpleFigureView1.setP2(DVector.valueOf("[1.414214,1.414214]"));
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setPreferredSize(new java.awt.Dimension(330, 390));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.X_AXIS));
    
    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setOpaque(true);
    textSlider1.setDescription("\u03c3 =");
    textSlider1.setLogarithmic(true);
    textSlider1.setModel(new BoundedRealModel(0.1,1.0,10.0));
    textSlider1.setUnit("");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider1);
    
    integerTextSlider1.setDescription(java.util.ResourceBundle.getBundle("physapps.mathematics.MonteCarloE", currentLocale).getString("s1"));
    integerTextSlider1.setLogarithmic(true);
    integerTextSlider1.setModel(new BoundedRealModel(1.0,1000.0,1000000.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
      }
    });
    
    inputPanel.add(integerTextSlider1);
    
    jPanel1.add(inputPanel, java.awt.BorderLayout.NORTH);
    
    objectPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createEmptyBorder(4, 4, 4, 4)));
    objectPanel1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(3.0);
    layeredScreen1.setMinX(-3.0);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1, java.awt.BorderLayout.CENTER);
    
    outputPanel1.setBordered(true);
    numericTextField1.setDescription(java.util.ResourceBundle.getBundle("physapps.mathematics.MonteCarloE", currentLocale).getString("s3"));
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(6);
    numericTextField1.setUnit("");
    outputPanel1.add(numericTextField1);
    
    numericTextField2.setDescription(java.util.ResourceBundle.getBundle("physapps.mathematics.MonteCarloE", currentLocale).getString("s5"));
    numericTextField2.setEditable(false);
    numericTextField2.setPrecision(6);
    numericTextField2.setUnit("");
    outputPanel1.add(numericTextField2);
    
    jPanel1.add(outputPanel1, java.awt.BorderLayout.SOUTH);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    normalRandomVector1.setStandardDeviation(textSlider1.getValue());
    normalRandomVector2.setStandardDeviation(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void normalRandomVector2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_normalRandomVector2ValueChanged
    pointView1.setModel(normalRandomVector1.getOutputVector(), normalRandomVector2.getOutputVector());
    parsedVectorFunction1.setInputVector(1, normalRandomVector2.getOutputVector());
    parsedVectorFunction1.trigger();
  }//GEN-LAST:event_normalRandomVector2ValueChanged
  
  private void normalRandomVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_normalRandomVector1ValueChanged
    parsedVectorFunction1.setInputVector(0, normalRandomVector1.getOutputVector());
  }//GEN-LAST:event_normalRandomVector1ValueChanged
  
  private void pointView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointView1SourceChanged
    layeredScreen1.addView(pointView1);
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_pointView1SourceChanged
  
  private void parsedVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedVectorFunction1ValueChanged
    sumFunction1.setInputVector(parsedVectorFunction1.getOutputVector());
  }//GEN-LAST:event_parsedVectorFunction1ValueChanged
  
  private void sumFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_sumFunction1ValueChanged
    double d = sumFunction1.getOutputValue();
    numericTextField1.setValue(d);
    arithmeticFunction1.setThirdArg(d);
  }//GEN-LAST:event_sumFunction1ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    numericTextField2.setValue(arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    int n = integerTextSlider1.getValueAsInt();
    normalRandomVector1.setOutputSize(n);
    normalRandomVector2.setOutputSize(n);
    arithmeticFunction1.setFourthArg(n);
  }//GEN-LAST:event_integerTextSlider1PropertyChange
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.NormalRandomVector normalRandomVector1;
  protected physbeans.func.NormalRandomVector normalRandomVector2;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.NumericTextField numericTextField2;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.ParsedVectorFunction parsedVectorFunction1;
  protected physbeans.views.PointView pointView1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.func.SumFunction sumFunction1;
  protected physbeans.inout.TextSlider textSlider1;
// End of variables declaration//GEN-END:variables
  
}
