package physapps.mechanics;

import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class Acceleration extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new Acceleration(), 645, 400);
  }

  /**
   * Creates new form Simulation
   */
  public void init() {
    setLocale();
    initComponents();
  }

  /**&
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    generic1DMassPoint1 = new physbeans.phys.Generic1DMassPoint();
    singleMassView1 = new physbeans.views.SingleMassView();
    vectorDecompositionView1 = new physbeans.views.VectorDecompositionView();
    multiplexer1 = new physbeans.func.Multiplexer();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderS0 = new physbeans.inout.TextSlider();
    textSliderV0 = new physbeans.inout.TextSlider();
    textSliderA = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    generic1DMassPoint1.setFunction("a");
    generic1DMassPoint1.setParameterName(new String[] {"a"});
    generic1DMassPoint1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        generic1DMassPoint1ValueChanged1(evt);
        generic1DMassPoint1ValueChanged(evt);
      }
    });

    singleMassView1.setMassHeight(20.0);
    singleMassView1.setMassWidth(20.0);
    singleMassView1.setPosition(DVector.valueOf("[0.0,0.0]"));
    singleMassView1.setSquare(false);
    singleMassView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        singleMassView1SourceChanged(evt);
      }
    });

    vectorDecompositionView1.setDepth(40);
    vectorDecompositionView1.setInitialValues(DVector.valueOf("[0.0,0.0,1.0,0.0]"));

    multiplexer1.setAutoTriggered(false);
    multiplexer1.setCollectInput(false);
    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(500.0);
    layeredScreen1.setMinX(-20.0);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.LINE_AXIS));

    oscilloscope1.setNLines(3);
    oscilloscope1.setMaxY(500.0);
    oscilloscope1.setMinY(0.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mechanics.Acceleration", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(0.025);
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.025);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    inputPanel1.add(timer1);

    textSliderS0.setDescription("s(0) = ");
    textSliderS0.setModel(new BoundedRealModel(0.0,0.0,500.0));
    textSliderS0.setPrecision(3);
    textSliderS0.setUnit("m");
    textSliderS0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderS0PropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderS0);

    textSliderV0.setDescription("v(0) =");
    textSliderV0.setModel(new BoundedRealModel(-100.0,0.0,100.0));
    textSliderV0.setPrecision(3);
    textSliderV0.setUnit("m/s");
    textSliderV0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderV0PropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderV0);

    textSliderA.setDescription("a =");
    textSliderA.setModel(new BoundedRealModel(-20.0,10.0,20.0));
    textSliderA.setPrecision(3);
    textSliderA.setUnit("1/s\u00b2");
    textSliderA.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderAPropertyChange(evt);
        textSliderAPropertyChange1(evt);
      }
    });
    inputPanel1.add(textSliderA);

    switchBox1.setBoxLabel(new String[] {
      bundle.getString("s1"),
      bundle.getString("s2"),
      bundle.getString("s3")
    });
    switchBox1.setTitle(bundle.getString("s4")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox1);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    singleMassView1.restart();
    vectorDecompositionView1.restart();
  }//GEN-LAST:event_timer1Restart2

  private void singleMassView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_singleMassView1SourceChanged
    layeredScreen1.addView(singleMassView1);
    layeredScreen1.addView(vectorDecompositionView1);
  }//GEN-LAST:event_singleMassView1SourceChanged

  private void generic1DMassPoint1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic1DMassPoint1ValueChanged1
    double x = generic1DMassPoint1.getOutputValue();
    double v = generic1DMassPoint1.getOutputValues(1);
    singleMassView1.setXPosition(x);
    vectorDecompositionView1.setPosition(new DVector(x, 0.0));
    vectorDecompositionView1.setVector(new DVector(v, 0.0));
  }//GEN-LAST:event_generic1DMassPoint1ValueChanged1

  private void textSliderAPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderAPropertyChange
    generic1DMassPoint1.setParameter(0, textSliderA.getValue());
  }//GEN-LAST:event_textSliderAPropertyChange

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void textSliderV0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV0PropertyChange
    double val = textSliderV0.getValue();
    generic1DMassPoint1.setV0(val);
    vectorDecompositionView1.setInitialValue(2, val);
  }//GEN-LAST:event_textSliderV0PropertyChange

  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    generic1DMassPoint1.restart();
  }//GEN-LAST:event_timer1Restart1

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    generic1DMassPoint1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart

    private void generic1DMassPoint1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic1DMassPoint1ValueChanged
      multiplexer1.setInputValueFromVector(0, generic1DMassPoint1.getOutputVector());
      multiplexer1.trigger();
    }//GEN-LAST:event_generic1DMassPoint1ValueChanged

  private void textSliderAPropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderAPropertyChange1
    multiplexer1.setInputValues(2, textSliderA.getValue());
  }//GEN-LAST:event_textSliderAPropertyChange1

  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged

  private void textSliderS0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderS0PropertyChange
    double val = textSliderS0.getValue();
    generic1DMassPoint1.setX0(val);
    singleMassView1.setInitialValue(0, val);
    vectorDecompositionView1.setInitialValue(0, val);
  }//GEN-LAST:event_textSliderS0PropertyChange


  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.Generic1DMassPoint generic1DMassPoint1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.views.SingleMassView singleMassView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderA;
  protected physbeans.inout.TextSlider textSliderS0;
  protected physbeans.inout.TextSlider textSliderV0;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.VectorDecompositionView vectorDecompositionView1;
  // End of variables declaration//GEN-END:variables

}
