package physapps.mechanics;

import physbeans.inout.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class InelasticCollision extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new InelasticCollision(), 750, 500);
  }

  /**
   * Creates new form Simulation
   */
  public void init() {
    setLocale();
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    collision1D1 = new physbeans.phys.Collision1D();
    twoDMassesView1 = new physbeans.views.TwoDMassesView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    physicsPanel1 = new physbeans.inout.PhysicsPanel();
    vectorTextFieldV = new physbeans.inout.VectorTextField();
    vectorTextFieldE = new physbeans.inout.VectorTextField();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderX0 = new physbeans.inout.VectorSlider();
    vectorSliderM = new physbeans.inout.VectorSlider();
    vectorSliderV0 = new physbeans.inout.VectorSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    collision1D1.setElasticity(0.0);
    collision1D1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        collision1D1SourceChanged(evt);
      }
    });
    collision1D1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        collision1D1ValueChanged(evt);
        collision1D1ValueChanged1(evt);
      }
    });

    twoDMassesView1.setColor(new java.awt.Color(0, 97, 255));
    twoDMassesView1.setInitialValues(DVector.valueOf("[2.0,0.0,-2.0,0.0,0.0,0.0]"));
    twoDMassesView1.setMarkerRadius(0.05);
    twoDMassesView1.setShowLastAsMarker(true);
    twoDMassesView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        twoDMassesView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(4.5);
    layeredScreen1.setMinX(-4.5);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setLayout(new java.awt.BorderLayout());

    physicsPanel1.setBordered(true);
    physicsPanel1.setLayout(new javax.swing.BoxLayout(physicsPanel1, javax.swing.BoxLayout.Y_AXIS));

    vectorTextFieldV.setDescription(new String[] {"v1 =", "v2 ="});
    vectorTextFieldV.setUnit(new String[] {"m/s", "m/s"});
    physicsPanel1.add(vectorTextFieldV);

    vectorTextFieldE.setDescription(new String[] {"E1 =", "E2 ="});
    vectorTextFieldE.setUnit(new String[] {"J", "J"});
    physicsPanel1.add(vectorTextFieldE);

    outputPanel.add(physicsPanel1, java.awt.BorderLayout.WEST);

    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[] {true, true, true});
    oscilloscope1.setMaxY(5.0);
    oscilloscope1.setMinY(-5.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mechanics.InelasticCollision", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(0.025);
    outputPanel.add(oscilloscope1, java.awt.BorderLayout.CENTER);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.025);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSliderX0.setCount(2);
    vectorSliderX0.setDescription("x0 =");
    vectorSliderX0.setInitialValues(DVector.valueOf("[-2.0,2.0]"));
    vectorSliderX0.setMaximum(2.0);
    vectorSliderX0.setMinimum(-2.0);
    vectorSliderX0.setUnit("m");
    vectorSliderX0.setVertical(false);
    vectorSliderX0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderX0PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderX0);

    vectorSliderM.setCount(2);
    vectorSliderM.setDescription("m =");
    vectorSliderM.setInitialValues(DVector.valueOf("[3.0,5.0]"));
    vectorSliderM.setMaximum(10.0);
    vectorSliderM.setMinimum(0.01);
    vectorSliderM.setUnit("kg");
    vectorSliderM.setVertical(false);
    vectorSliderM.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderMPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderM);

    vectorSliderV0.setCount(2);
    vectorSliderV0.setDescription("v0 =");
    vectorSliderV0.setInitialValues(DVector.valueOf("[0.0,-1.0]"));
    vectorSliderV0.setMaximum(2.0);
    vectorSliderV0.setMinimum(-2.0);
    vectorSliderV0.setUnit("m/s");
    vectorSliderV0.setVertical(false);
    vectorSliderV0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderV0PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderV0);

    switchBox1.setBoxLabel(new String[] {"x1", "x2", "xCms"});
    switchBox1.setSelected(new boolean[] {true, true, true});
    switchBox1.setTitle(bundle.getString("s1")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    collision1D1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void collision1D1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_collision1D1ValueChanged
    oscilloscope1.setInputVector(collision1D1.getOutputVector());
  }//GEN-LAST:event_collision1D1ValueChanged

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
    twoDMassesView1.restart();
  }//GEN-LAST:event_timer1Restart

  private void vectorSliderMPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderMPropertyChange
    collision1D1.setMasses(vectorSliderM.getValue());
    twoDMassesView1.setRadii(collision1D1.getRadii());
  }//GEN-LAST:event_vectorSliderMPropertyChange

  private void vectorSliderV0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderV0PropertyChange
    collision1D1.setInitialVelocities(vectorSliderV0.getValue());
  }//GEN-LAST:event_vectorSliderV0PropertyChange

  private void vectorSliderX0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderX0PropertyChange
    collision1D1.setInitialPositions(vectorSliderX0.getValue());
  }//GEN-LAST:event_vectorSliderX0PropertyChange

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void twoDMassesView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_twoDMassesView1SourceChanged
    layeredScreen1.addView(twoDMassesView1);
  }//GEN-LAST:event_twoDMassesView1SourceChanged

  private void collision1D1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_collision1D1ValueChanged1
    twoDMassesView1.setPositions1D(collision1D1.getOutputVector());
    vectorTextFieldV.setValue(collision1D1.getVelocities());
    vectorTextFieldE.setValue(collision1D1.getEnergies());
  }//GEN-LAST:event_collision1D1ValueChanged1

  private void collision1D1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_collision1D1SourceChanged
    twoDMassesView1.setInitialValues1D(collision1D1.getAllInitialPositions());
  }//GEN-LAST:event_collision1D1SourceChanged


  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.Collision1D collision1D1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.inout.PhysicsPanel physicsPanel1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.TwoDMassesView twoDMassesView1;
  protected physbeans.inout.VectorSlider vectorSliderM;
  protected physbeans.inout.VectorSlider vectorSliderV0;
  protected physbeans.inout.VectorSlider vectorSliderX0;
  protected physbeans.inout.VectorTextField vectorTextFieldE;
  protected physbeans.inout.VectorTextField vectorTextFieldV;
  // End of variables declaration//GEN-END:variables

}
