package physapps.mechanics;

import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class LaminarThrow extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new LaminarThrow(), 780, 580);
  }

  /**
   * Creates new form Simulation
   */
  public void init() {
    setLocale();
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    polar2CartFunction1 = new physbeans.func.Polar2CartFunction();
    generic2DMassPoint1 = new physbeans.phys.Generic2DMassPoint();
    vectorDecompositionView1 = new physbeans.views.VectorDecompositionView();
    barView1 = new physbeans.views.BarView();
    labelView1 = new physbeans.views.LabelView();
    labelView2 = new physbeans.views.LabelView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    xYScope1 = new physbeans.inout.XYScope();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderY0 = new physbeans.inout.TextSlider();
    textSliderV0 = new physbeans.inout.TextSlider();
    textSliderPhi0 = new physbeans.inout.TextSlider();
    textSliderG = new physbeans.inout.TextSlider();
    textSliderB = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    polar2CartFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        polar2CartFunction1ValueChanged(evt);
      }
    });

    generic2DMassPoint1.setFunctionX("-b*vx");
    generic2DMassPoint1.setFunctionY("-b*vy - m*g");
    generic2DMassPoint1.setParameter(DVector.valueOf("[9.81,0.5]"));
    generic2DMassPoint1.setParameterName(new String[] {"g", "b"});
    generic2DMassPoint1.setX0(DVector.valueOf("[0.0,0.0]"));
    generic2DMassPoint1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        generic2DMassPoint1SourceChanged(evt);
      }
    });
    generic2DMassPoint1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        generic2DMassPoint1ValueChanged(evt);
      }
    });

    vectorDecompositionView1.setDepth(40);
    vectorDecompositionView1.setMarkerSize(10);
    vectorDecompositionView1.setShowMarker(true);
    vectorDecompositionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        vectorDecompositionView1SourceChanged(evt);
      }
    });

    barView1.setBarWidth(0.8);
    barView1.setEqualBarColor(false);
    barView1.setInitialValues(DVector.valueOf("[800.0,490.5,1290.5]"));
    barView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        barView1SourceChanged(evt);
      }
    });

    labelView1.setDepth(40);
    labelView1.setInitialValues(new String[] {"800", "490.5", "1290.5"});
    labelView1.setPrecision(3);

    labelView2.setDepth(30);
    labelView2.setInitialValues(new String[] {"Ekin", "Epot", "Eges"});
    labelView2.setPosition(1.0);

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    xYScope1.setBufferSize(10240);
    xYScope1.setLineColor(new Color[]{
      new Color(0, 0, 0),
      new Color(255, 0, 255),
      new Color(0, 255, 255),
      new Color(255, 175, 175),
      new Color(255, 200, 0),
      new Color(255, 0, 0),
      new Color(0, 0, 255),
      new Color(255, 255, 0)});
  xYScope1.setMaxX(200.0);
  xYScope1.setMaxY(100.0);
  xYScope1.setMinX(-10.0);
  xYScope1.setMinY(-10.0);
  java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mechanics.LaminarThrow", currentLocale); // NOI18N
  xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
  xYScope1.setScaleLabel("x: ");
  xYScope1.setScaleLabel2("y: ");
  xYScope1.setScreenBackground(new java.awt.Color(255, 255, 255));
  xYScope1.setTwoScalePanels(true);
  objectPanel.add(xYScope1, java.awt.BorderLayout.CENTER);

  jPanel2.add(objectPanel);

  outputPanel.setBackground(new java.awt.Color(150, 200, 255));
  outputPanel.setBordered(true);
  outputPanel.setFont(standardFont);
  outputPanel.setOpaque(true);
  outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.X_AXIS));

  oscilloscope1.setNLines(4);
  oscilloscope1.setLineActive(new boolean[]{true,true,false,false});
  oscilloscope1.setMaxY(200.0);
  oscilloscope1.setMinY(-50.0);
  oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
  oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
  oscilloscope1.setTimePerTick(0.02);
  outputPanel.add(oscilloscope1);

  layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
  layeredScreen1.setBordered(true);
  layeredScreen1.setCrossCursor(true);
  layeredScreen1.setMaxX(2.9);
  layeredScreen1.setMaxY(3000.0);
  layeredScreen1.setMinX(-0.1);
  layeredScreen1.setMinY(-500.0);
  layeredScreen1.setOpaque(true);
  outputPanel.add(layeredScreen1);

  jPanel2.add(outputPanel);

  jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

  inputPanel.setBackground(new java.awt.Color(100, 255, 255));
  inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
  inputPanel.setFont(standardFont);
  inputPanel.setOpaque(true);
  inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
  inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

  timer1.setDelay(20L);
  timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
  timer1.setTimeIncrement(0.02);
  timer1.addTimerListener(new physbeans.event.TimerListener() {
    public void nextStep(physbeans.event.NextStepEvent evt) {
      timer1NextStep(evt);
    }
    public void restart(physbeans.event.RestartEvent evt) {
      timer1Restart(evt);
    }
  });
  inputPanel.add(timer1);

  textSliderY0.setDescription("y(0) =");
  textSliderY0.setModel(new BoundedRealModel(0.0,50.0,100.0));
  textSliderY0.setUnit("m");
  textSliderY0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderY0PropertyChange(evt);
    }
  });
  inputPanel.add(textSliderY0);

  textSliderV0.setDescription("v(0) =");
  textSliderV0.setModel(new BoundedRealModel(0.0,40.0,100.0));
  textSliderV0.setUnit("m/s");
  textSliderV0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderV0PropertyChange(evt);
    }
  });
  inputPanel.add(textSliderV0);

  textSliderPhi0.setDescription("\u03b1(0) =");
  textSliderPhi0.setModel(new BoundedRealModel(-0.5,0.25,0.5));
  textSliderPhi0.setUnit("* \u03c0");
  textSliderPhi0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderPhi0PropertyChange(evt);
    }
  });
  inputPanel.add(textSliderPhi0);

  textSliderG.setDescription("g =");
  textSliderG.setModel(new BoundedRealModel(0.0,9.81,20.0));
  textSliderG.setUnit("1/s\u00b2");
  textSliderG.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderGPropertyChange(evt);
    }
  });
  inputPanel.add(textSliderG);

  textSliderB.setColumns(6);
  textSliderB.setDescription("b/m =");
  textSliderB.setLogarithmic(true);
  textSliderB.setModel(new BoundedRealModel(0.001,0.1,1.0));
  textSliderB.setUnit("1/m");
  textSliderB.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSliderBPropertyChange(evt);
    }
  });
  inputPanel.add(textSliderB);

  switchBox1.setBoxLabel(new String[] {"x", "y", "vx", "vy"});
  switchBox1.setSelected(new boolean[]{true,true,false,false});
  switchBox1.setTitle(bundle.getString("s1")); // NOI18N
  switchBox1.setWithTwoColumns(true);
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel.add(switchBox1);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void textSliderBPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderBPropertyChange
    generic2DMassPoint1.setParameter(1, textSliderB.getValue());
  }//GEN-LAST:event_textSliderBPropertyChange

  private void polar2CartFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_polar2CartFunction1ValueChanged
    generic2DMassPoint1.setV0(polar2CartFunction1.getOutputVector());
  }//GEN-LAST:event_polar2CartFunction1ValueChanged

  private void textSliderPhi0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderPhi0PropertyChange
    polar2CartFunction1.setPhi(textSliderPhi0.getValue() * Math.PI);
  }//GEN-LAST:event_textSliderPhi0PropertyChange

  private void textSliderV0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV0PropertyChange
    polar2CartFunction1.setR(textSliderV0.getValue());
  }//GEN-LAST:event_textSliderV0PropertyChange

  private void textSliderGPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderGPropertyChange
    double val = textSliderG.getValue();
    generic2DMassPoint1.setParameter(0, val);
  }//GEN-LAST:event_textSliderGPropertyChange

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
    generic2DMassPoint1.restart();
    xYScope1.restart();
    vectorDecompositionView1.restart();
    labelView1.restart();
    barView1.restart();
  }//GEN-LAST:event_timer1Restart

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void generic2DMassPoint1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic2DMassPoint1ValueChanged
    DVector vals = generic2DMassPoint1.getOutputVector();
    oscilloscope1.setInputVector(vals);
    xYScope1.setInputVector(generic2DMassPoint1.getPosition());
    vectorDecompositionView1.setPosition(generic2DMassPoint1.getPosition());
    vectorDecompositionView1.setVector(generic2DMassPoint1.getVelocity());
    DVector energies = generic2DMassPoint1.getEnergies();
    barView1.setModel(energies);
    labelView1.setValues(energies);
    if (vals.get(1) <= 0) {timer1.changeTimerState();}
  }//GEN-LAST:event_generic2DMassPoint1ValueChanged

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    generic2DMassPoint1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void textSliderY0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderY0PropertyChange
    double val = textSliderY0.getValue();
    generic2DMassPoint1.setInitialValue(1, val);
  }//GEN-LAST:event_textSliderY0PropertyChange

  private void vectorDecompositionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_vectorDecompositionView1SourceChanged
    xYScope1.addView(vectorDecompositionView1);
  }//GEN-LAST:event_vectorDecompositionView1SourceChanged

  private void barView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged
    layeredScreen1.addView(barView1);
    layeredScreen1.addView(labelView1);
    layeredScreen1.addView(labelView2);
  }//GEN-LAST:event_barView1SourceChanged

    private void generic2DMassPoint1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_generic2DMassPoint1SourceChanged
      DVector vals = generic2DMassPoint1.getInitialValues();
      vectorDecompositionView1.setInitialValues(vals);
      DVector energies = generic2DMassPoint1.getEnergies();
      barView1.setInitialValues(energies);
      labelView1.setInitialValues(energies);
      xYScope1.restart();
    }//GEN-LAST:event_generic2DMassPoint1SourceChanged

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.BarView barView1;
  protected physbeans.phys.Generic2DMassPoint generic2DMassPoint1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.LabelView labelView1;
  protected physbeans.views.LabelView labelView2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.Polar2CartFunction polar2CartFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderB;
  protected physbeans.inout.TextSlider textSliderG;
  protected physbeans.inout.TextSlider textSliderPhi0;
  protected physbeans.inout.TextSlider textSliderV0;
  protected physbeans.inout.TextSlider textSliderY0;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.VectorDecompositionView vectorDecompositionView1;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables

}
