package physapps.mechanics;

import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class UniformCircularMotion extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new UniformCircularMotion(), 580, 580);
  }

  /**
   * Creates new form Simulation
   */
  public void init() {
    setLocale();
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        parsedFunction1 = new physbeans.func.ParsedFunction();
        selector1 = new physbeans.func.Selector();
        vectorDecompositionView1 = new physbeans.views.VectorDecompositionView();
        selector2 = new physbeans.func.Selector();
        selector3 = new physbeans.func.Selector();
        vectorDecompositionView2 = new physbeans.views.VectorDecompositionView();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        objectPanel = new physbeans.inout.PhysicsPanel();
        xYScope1 = new physbeans.inout.XYScope();
        outputPanel = new physbeans.inout.PhysicsPanel();
        oscilloscope1 = new physbeans.inout.Oscilloscope();
        inputPanel = new physbeans.inout.PhysicsPanel();
        timer1 = new physbeans.inout.Timer();
        textSliderR = new physbeans.inout.TextSlider();
        textSliderOm = new physbeans.inout.TextSlider();
        switchBox2 = new physbeans.inout.SwitchBox();
        switchBox1 = new physbeans.inout.SwitchBox();

        parsedFunction1.setFunction(new String[] {"r*cos(om*t)", "r*sin(om*t)", "-r*om*sin(om*t)", "r*om*cos(om*t)", "-r*om*om*cos(om*t)", "-r*om*om*sin(om*t)", "r*om", "r*om*om"});
        parsedFunction1.setParameter(DVector.valueOf("[1.0,1.0]"));
        parsedFunction1.setVariableName(new String[] {"t", "r", "om"});
        parsedFunction1.addVectorListener(new physbeans.event.VectorListener() {
            public void valueChanged(physbeans.event.VectorEvent evt) {
                parsedFunction1ValueChanged(evt);
            }
        });

        selector1.setIndex(new int[] {0, 1, 2, 3});
        selector1.setInputLength(8);
        selector1.setOutputLength(4);
        selector1.addVectorListener(new physbeans.event.VectorListener() {
            public void valueChanged(physbeans.event.VectorEvent evt) {
                selector1ValueChanged(evt);
            }
        });

        vectorDecompositionView1.setDepth(45);
        vectorDecompositionView1.setInitialValues(DVector.valueOf("[1.0,0.0,0.0,1.0]"));
        vectorDecompositionView1.setMarkerSize(10);
        vectorDecompositionView1.setShowMarker(true);
        vectorDecompositionView1.addTriggerListener(new physbeans.event.TriggerListener() {
            public void sourceChanged(physbeans.event.TriggerEvent evt) {
                vectorDecompositionView1SourceChanged(evt);
            }
        });

        selector2.setIndex(new int[] {0, 1});
        selector2.setInputLength(8);
        selector2.setOutputLength(2);
        selector2.addVectorListener(new physbeans.event.VectorListener() {
            public void valueChanged(physbeans.event.VectorEvent evt) {
                selector2ValueChanged(evt);
            }
        });

        selector3.setIndex(new int[] {0, 1, 4, 5});
        selector3.setInputLength(8);
        selector3.setOutputLength(4);
        selector3.addVectorListener(new physbeans.event.VectorListener() {
            public void valueChanged(physbeans.event.VectorEvent evt) {
                selector3ValueChanged(evt);
            }
        });

        vectorDecompositionView2.setArrowColor(new java.awt.Color(0, 0, 255));
        vectorDecompositionView2.setDepth(40);
        vectorDecompositionView2.setInitialValues(DVector.valueOf("[1.0,0.0,1.0,0.0]"));
        vectorDecompositionView2.setMarkerSize(10);
        vectorDecompositionView2.setShowMarker(true);
        vectorDecompositionView2.addTriggerListener(new physbeans.event.TriggerListener() {
            public void sourceChanged(physbeans.event.TriggerEvent evt) {
                vectorDecompositionView2SourceChanged(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
        jPanel1.setFont(standardFont);
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel2.setFont(standardFont);
        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

        objectPanel.setBackground(new java.awt.Color(255, 255, 175));
        objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
        objectPanel.setFont(standardFont);
        objectPanel.setOpaque(true);
        objectPanel.setLayout(new java.awt.BorderLayout());

        xYScope1.setBufferSize(10240);
        xYScope1.setDotSize(5);
        xYScope1.setEqualScales(true);
        xYScope1.setLineColor(new Color[]{
            new Color(0, 0, 0),
            new Color(255, 0, 255),
            new Color(0, 255, 255),
            new Color(255, 175, 175),
            new Color(255, 200, 0),
            new Color(255, 0, 0),
            new Color(0, 0, 255),
            new Color(255, 255, 0)});
    xYScope1.setMaxX(2.5);
    xYScope1.setMinX(-2.5);
    xYScope1.setMinY(-2.5);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mechanics.UniformCircularMotion", currentLocale); // NOI18N
    xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    xYScope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    xYScope1.setScaleX(true);
    xYScope1.setScreenBackground(new java.awt.Color(255, 255, 255));
    xYScope1.setShowMarker(true);
    objectPanel.add(xYScope1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    oscilloscope1.setNLines(8);
    oscilloscope1.setLineActive(new boolean[] {true, true, false, false, false, false, false, false});
    oscilloscope1.setMaxY(3.0);
    oscilloscope1.setMinY(-3.0);
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(0.05);
    outputPanel.add(oscilloscope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.05);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
        public void nextStep(physbeans.event.NextStepEvent evt) {
            timer1NextStep(evt);
        }
        public void restart(physbeans.event.RestartEvent evt) {
            timer1Restart(evt);
        }
    });
    inputPanel.add(timer1);

    textSliderR.setDescription("r =");
    textSliderR.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSliderR.setUnit("m");
    textSliderR.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
        public void propertyChange(java.beans.PropertyChangeEvent evt) {
            textSliderRPropertyChange(evt);
        }
    });
    inputPanel.add(textSliderR);

    textSliderOm.setDescription("\u03c9 =");
    textSliderOm.setModel(new BoundedRealModel(-3.0,1.0,3.0));
    textSliderOm.setUnit("1/s");
    textSliderOm.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
        public void propertyChange(java.beans.PropertyChangeEvent evt) {
            textSliderOmPropertyChange(evt);
        }
    });
    inputPanel.add(textSliderOm);

    switchBox2.setBoxLabel(new String[] {
        bundle.getString("s3"),
        bundle.getString("s4"),
        bundle.getString("s5")
    });
    switchBox2.setSelected(new boolean[] {true, true, true});
    switchBox2.setTitle(bundle.getString("s2")); // NOI18N
    switchBox2.addSwitchListener(new physbeans.event.SwitchListener() {
        public void valueChanged(physbeans.event.SwitchEvent evt) {
            switchBox2ValueChanged(evt);
        }
    });
    inputPanel.add(switchBox2);

    switchBox1.setBoxLabel(new String[] {"x", "y", "vx", "vy", "ax", "ay", "v", "a"});
    switchBox1.setSelected(new boolean[]{true,true,false,false,false,false,false,false});
    switchBox1.setTitle(bundle.getString("s1")); // NOI18N
    switchBox1.setWithTwoColumns(true);
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
        public void valueChanged(physbeans.event.SwitchEvent evt) {
            switchBox1ValueChanged(evt);
        }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
    xYScope1.restart();
    vectorDecompositionView1.restart();
    vectorDecompositionView2.restart();
  }//GEN-LAST:event_timer1Restart

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void vectorDecompositionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_vectorDecompositionView1SourceChanged
    xYScope1.addView(vectorDecompositionView1);
  }//GEN-LAST:event_vectorDecompositionView1SourceChanged

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    parsedFunction1.singleInputValue(0, timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void parsedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunction1ValueChanged
    DVector val = parsedFunction1.getOutputVector();
    oscilloscope1.setInputVector(val);
    selector1.setInputVector(val);
    selector2.setInputVector(val);
    selector3.setInputVector(val);
  }//GEN-LAST:event_parsedFunction1ValueChanged

  private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
    vectorDecompositionView1.setModel(selector1.getOutputVector());
  }//GEN-LAST:event_selector1ValueChanged

  private void selector2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector2ValueChanged
    xYScope1.setInputVector(selector2.getOutputVector());
  }//GEN-LAST:event_selector2ValueChanged

  private void textSliderRPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderRPropertyChange
    double r = textSliderR.getValue();
    double om = textSliderOm.getValue();
    parsedFunction1.setParameter(0, r);
    vectorDecompositionView1.setInitialValue(0, r);
    vectorDecompositionView1.setInitialValue(3, r * om);
    vectorDecompositionView2.setInitialValue(0, r);
    vectorDecompositionView2.setInitialValue(2, -r * om * om);
  }//GEN-LAST:event_textSliderRPropertyChange

  private void textSliderOmPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderOmPropertyChange
    double r = textSliderR.getValue();
    double om = textSliderOm.getValue();
    parsedFunction1.setParameter(1, om);
    vectorDecompositionView1.setInitialValue(0, r);
    vectorDecompositionView1.setInitialValue(3, r * om);
    vectorDecompositionView2.setInitialValue(0, r);
    vectorDecompositionView2.setInitialValue(2, -r * om * om);
  }//GEN-LAST:event_textSliderOmPropertyChange

  private void selector3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector3ValueChanged
    vectorDecompositionView2.setModel(selector3.getOutputVector());
  }//GEN-LAST:event_selector3ValueChanged

  private void vectorDecompositionView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_vectorDecompositionView2SourceChanged
    xYScope1.addView(vectorDecompositionView2);
  }//GEN-LAST:event_vectorDecompositionView2SourceChanged

  private void switchBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged
    xYScope1.setViewActive(switchBox2.getSelected());
  }//GEN-LAST:event_switchBox2ValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected physbeans.inout.PhysicsPanel inputPanel;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JPanel jPanel2;
    protected physbeans.inout.PhysicsPanel objectPanel;
    protected physbeans.inout.Oscilloscope oscilloscope1;
    protected physbeans.inout.PhysicsPanel outputPanel;
    protected physbeans.func.ParsedFunction parsedFunction1;
    protected physbeans.func.Selector selector1;
    protected physbeans.func.Selector selector2;
    protected physbeans.func.Selector selector3;
    protected physbeans.inout.SwitchBox switchBox1;
    protected physbeans.inout.SwitchBox switchBox2;
    protected physbeans.inout.TextSlider textSliderOm;
    protected physbeans.inout.TextSlider textSliderR;
    protected physbeans.inout.Timer timer1;
    protected physbeans.views.VectorDecompositionView vectorDecompositionView1;
    protected physbeans.views.VectorDecompositionView vectorDecompositionView2;
    protected physbeans.inout.XYScope xYScope1;
    // End of variables declaration//GEN-END:variables

}
