package physapps.nonlinear;

import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class Poincare extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new Poincare(), 554, 410);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    mathPendulum1 = new physbeans.phys.MathPendulum();
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    reducePhaseFunction1 = new physbeans.func.ReducePhaseFunction();
    mergeFunction1 = new physbeans.func.MergeFunction();
    delayedOn1 = new physbeans.func.DelayedOn();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    xYScope1 = new physbeans.inout.XYScope();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();

    mathPendulum1.setB(1.0);
    mathPendulum1.setExternalTorqueFunction(harmonicVectorFunction1);
    mathPendulum1.setG(1.0);
    mathPendulum1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mathPendulum1ValueChanged(evt);
      }
    });

    reducePhaseFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        reducePhaseFunction1ValueChanged(evt);
      }
    });

    mergeFunction1.setUseFirstVector(new boolean[]{true,false});
    mergeFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mergeFunction1ValueChanged(evt);
      }
    });

    delayedOn1.setDelayTime(26.0);
    delayedOn1.setNullValue(Double.NaN);
    delayedOn1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        delayedOn1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());

    xYScope1.setBufferSize(10000);
    xYScope1.setDotted(true);
    xYScope1.setMaxX(3.2);
    xYScope1.setMaxY(3.2);
    xYScope1.setMinX(-3.2);
    xYScope1.setMinY(-3.2);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.nonlinear.Poincare", currentLocale); // NOI18N
    xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    xYScope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    xYScope1.setScaleX(true);
    objectPanel1.add(xYScope1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);

    outputPanel1.setBordered(true);

    numericTextField1.setDescription(bundle.getString("s3")); // NOI18N
    numericTextField1.setUnit("");
    outputPanel1.add(numericTextField1);

    jPanel2.add(outputPanel1, java.awt.BorderLayout.SOUTH);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("\u03b1 =");
    textSlider1.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider1.setUnit("* \u03c0");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription(bundle.getString("s1")); // NOI18N
    textSlider2.setLogarithmic(true);
    textSlider2.setModel(new BoundedRealModel(1.0,100.0,100000.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("\u03bb =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.5,2.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider4.setDescription("A =");
    textSlider4.setModel(new BoundedRealModel(0.0,1.2,2.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider5.setDescription("\u03c9_ext =");
    textSlider5.setModel(new BoundedRealModel(0.0,0.667,2.0));
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider5);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void reducePhaseFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_reducePhaseFunction1ValueChanged
    mergeFunction1.setFirstVector(reducePhaseFunction1.getOutputVector());
  }//GEN-LAST:event_reducePhaseFunction1ValueChanged

  private void mergeFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mergeFunction1ValueChanged
    delayedOn1.setInputVector(mergeFunction1.getOutputVector());
  }//GEN-LAST:event_mergeFunction1ValueChanged

  private void delayedOn1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_delayedOn1ValueChanged
    xYScope1.setInputVector(delayedOn1.getOutputVector());
  }//GEN-LAST:event_delayedOn1ValueChanged
  
  private void mathPendulum1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mathPendulum1ValueChanged
    reducePhaseFunction1.setInputVector(mathPendulum1.getOutputVector());
    mergeFunction1.setSecondVector(mathPendulum1.getOutputVector());
  }//GEN-LAST:event_mathPendulum1ValueChanged
      
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    double val = textSlider5.getValue();
    harmonicVectorFunction1.setOmega(val);
    timer1.setTimeIncrement(2*Math.PI/val);
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    harmonicVectorFunction1.setAmplitude(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    mathPendulum1.setB(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    delayedOn1.setDelayTime(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    timer1.setStartTime(textSlider1.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    mathPendulum1.restart();
    xYScope1.restart();
    numericTextField1.setValue(0.0);
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    double val = timer1.getTime();
    mathPendulum1.setTime(val);
    delayedOn1.setTime(val);
    numericTextField1.setValue(val);
  }//GEN-LAST:event_timer1NextStep
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.DelayedOn delayedOn1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.phys.MathPendulum mathPendulum1;
  protected physbeans.func.MergeFunction mergeFunction1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.ReducePhaseFunction reducePhaseFunction1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables
  
}
