package physapps.nonlinear;

import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class RandomDrivenPendulum extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new RandomDrivenPendulum(), 540, 540);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    mathPendulum1 = new physbeans.phys.MathPendulum();
    uniformRandomVector1 = new physbeans.func.UniformRandomVector();
    multiplexer1 = new physbeans.func.Multiplexer();
    selector1 = new physbeans.func.Selector();
    reducePhaseFunction1 = new physbeans.func.ReducePhaseFunction();
    mergeFunction1 = new physbeans.func.MergeFunction();
    pendulumView1 = new physbeans.views.PendulumView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    switchBox2 = new physbeans.inout.SwitchBox();

    mathPendulum1.setExternalTorqueFunction(uniformRandomVector1);
    mathPendulum1.setPhi0(0.0);
    mathPendulum1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mathPendulum1ValueChanged(evt);
      }
    });

    uniformRandomVector1.setOutputSize(1);
    uniformRandomVector1.setRandomize(true);
    uniformRandomVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        uniformRandomVector1ValueChanged(evt);
      }
    });

    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    selector1.setIndex(new int[]{0,2});
    selector1.setInputLength(3);
    selector1.setOutputLength(2);
    selector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selector1ValueChanged(evt);
      }
    });

    reducePhaseFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        reducePhaseFunction1ValueChanged(evt);
      }
    });

    mergeFunction1.setUseFirstVector(new boolean[]{true,false,false});
    mergeFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mergeFunction1ValueChanged(evt);
      }
    });

    pendulumView1.setArrowScale(0.2);
    pendulumView1.setInitialValues(DVector.valueOf("[0.5,0.0]"));
    pendulumView1.setShowArrow(true);
    pendulumView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pendulumView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setBordered(true);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[] {true, false, true});
    oscilloscope1.setMaxY(3.2);
    oscilloscope1.setMinY(-3.2);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.nonlinear.RandomDrivenPendulum", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(5L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("\u03c6(0) =");
    textSlider1.setModel(new BoundedRealModel(-1.0,1.0,1.0));
    textSlider1.setUnit("* \u03c0");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("d\u03c6/dt(0) =");
    textSlider2.setModel(new BoundedRealModel(-3.0,0.0,3.0));
    textSlider2.setUnit("");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("g/l =");
    textSlider3.setLogarithmic(true);
    textSlider3.setModel(new BoundedRealModel(0.1,1.0,10.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider4.setDescription("A =");
    textSlider4.setLogarithmic(true);
    textSlider4.setModel(new BoundedRealModel(1.0E-10,0.03,1.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    switchBox1.setBoxLabel( new String[] {
      bundle.getString("s1"),
      bundle.getString("s2"),
      bundle.getString("s3")
    });
    switchBox1.setSelected(new boolean[] {true, false, true});
    switchBox1.setTitle(bundle.getString("s4")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox1);

    switchBox2.setBoxLabel( new String[] {
      bundle.getString("s5")
    });
    switchBox2.setTitle("");
    switchBox2.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox2ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox2);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void mergeFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mergeFunction1ValueChanged
    oscilloscope1.setInputVector(mergeFunction1.getOutputVector());
  }//GEN-LAST:event_mergeFunction1ValueChanged

  private void reducePhaseFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_reducePhaseFunction1ValueChanged
    mergeFunction1.setFirstVector(reducePhaseFunction1.getOutputVector());
  }//GEN-LAST:event_reducePhaseFunction1ValueChanged

  private void pendulumView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pendulumView1SourceChanged
    layeredScreen1.addView(pendulumView1);
  }//GEN-LAST:event_pendulumView1SourceChanged
    
  private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
    pendulumView1.setModel(selector1.getOutputVector());
  }//GEN-LAST:event_selector1ValueChanged
  
  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    uniformRandomVector1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep1
  
  private void mathPendulum1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mathPendulum1ValueChanged
    multiplexer1.setInputValues(0, mathPendulum1.getOutputValues(0));
    multiplexer1.setInputValues(1, mathPendulum1.getOutputValues(1));
  }//GEN-LAST:event_mathPendulum1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    mathPendulum1.setG(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    mathPendulum1.restart();
    oscilloscope1.restart();
    pendulumView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    mathPendulum1.setOmega0(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue()*Math.PI;
    mathPendulum1.setPhi0(val);
    pendulumView1.setInitialValue(0, val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    mathPendulum1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
    
  private void switchBox2ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox2ValueChanged
    mergeFunction1.setUseFirstVector(0, switchBox2.getFirstSelected());
  }//GEN-LAST:event_switchBox2ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    reducePhaseFunction1.setInputVector(multiplexer1.getOutputVector());
    mergeFunction1.setSecondVector(multiplexer1.getOutputVector());
    selector1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
    
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    uniformRandomVector1.setMaxVal(val);
    uniformRandomVector1.setMinVal(-val);
  }//GEN-LAST:event_textSlider4PropertyChange

  private void uniformRandomVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_uniformRandomVector1ValueChanged
    multiplexer1.setInputValues(2, uniformRandomVector1.getOutputValue());
  }//GEN-LAST:event_uniformRandomVector1ValueChanged
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.MathPendulum mathPendulum1;
  protected physbeans.func.MergeFunction mergeFunction1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.views.PendulumView pendulumView1;
  protected physbeans.func.ReducePhaseFunction reducePhaseFunction1;
  protected physbeans.func.Selector selector1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.SwitchBox switchBox2;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  protected physbeans.func.UniformRandomVector uniformRandomVector1;
  // End of variables declaration//GEN-END:variables
  
}
