package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class FibreOptic extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new FibreOptic(), 650, 360);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    planeLightSource1 = new physbeans.phys.PlaneLightSource();
    planeLightSourceView1 = new physbeans.views.PlaneLightSourceView();
    glassPlane1 = new physbeans.phys.GlassPlane();
    glassPlaneView1 = new physbeans.views.GlassPlaneView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel = new physbeans.inout.PhysicsPanel();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    planeLightSource1.setPosition(-8.0);
    planeLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSource1SourceChanged(evt);
      }
    });
    
    glassPlane1.setHorizontal(true);
    glassPlane1.setIndexOfRefraction(1.8);
    glassPlane1.setIndexOfRefractionLeft(1.2);
    glassPlane1.setIndexOfRefractionRight(1.2);
    glassPlane1.setWidth(2.0);
    glassPlane1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        glassPlane1SourceChanged(evt);
        glassPlane1SourceChanged1(evt);
      }
    });
    
    glassPlaneView1.setDepth(60);
    glassPlaneView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        glassPlaneView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.X_AXIS));
    
    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    textSlider2.setDescription("d =");
    textSlider2.setModel(new BoundedRealModel(0.0,2.0,7.5));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider2);
    
    textSlider3.setDescription("\u03b1 =");
    textSlider3.setModel(new BoundedRealModel(-1.0,0.2,1.0));
    textSlider3.setUnit("\u03c0");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider3);
    
    textSlider4.setDescription("n =");
    textSlider4.setModel(new BoundedRealModel(1.0,1.5,3.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider4);
    
    jPanel1.add(inputPanel);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(10.0);
    layeredScreen1.setMinX(-10.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void glassPlaneView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_glassPlaneView1SourceChanged
    layeredScreen1.addView(glassPlaneView1);
    layeredScreen1.addView(planeLightSourceView1);
  }//GEN-LAST:event_glassPlaneView1SourceChanged

  private void planeLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSource1SourceChanged
    planeLightSourceView1.setModel(planeLightSource1);
    glassPlane1.propagate(planeLightSource1.getRays());
  }//GEN-LAST:event_planeLightSource1SourceChanged

  private void glassPlane1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_glassPlane1SourceChanged1
    glassPlaneView1.setModel(glassPlane1);
  }//GEN-LAST:event_glassPlane1SourceChanged1

  private void glassPlane1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_glassPlane1SourceChanged
    planeLightSource1.trigger();
  }//GEN-LAST:event_glassPlane1SourceChanged

  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    glassPlane1.setIndexOfRefraction(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange

  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    glassPlane1.setWidth(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange

  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    planeLightSource1.setAngle(textSlider3.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider3PropertyChange

  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.GlassPlane glassPlane1;
  protected physbeans.views.GlassPlaneView glassPlaneView1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PlaneLightSource planeLightSource1;
  protected physbeans.views.PlaneLightSourceView planeLightSourceView1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
