package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class SphericalMirror extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new SphericalMirror(), 650, 380);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    planeLightSource1 = new physbeans.phys.PlaneLightSource();
    planeLightSourceView1 = new physbeans.views.PlaneLightSourceView();
    sphericalMirror1 = new physbeans.phys.SphericalMirror();
    sphericalMirrorView1 = new physbeans.views.SphericalMirrorView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    planeLightSource1.setNRays(9);
    planeLightSource1.setPosition(-9.0);
    planeLightSource1.setWidth(1.5);
    planeLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSource1SourceChanged(evt);
      }
    });
    
    sphericalMirror1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        sphericalMirror1SourceChanged(evt);
        sphericalMirror1SourceChanged1(evt);
      }
    });
    
    sphericalMirrorView1.setDepth(60);
    sphericalMirrorView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        sphericalMirrorView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(1, 3));
    
    inputPanel1.setAlignmentX(0.5F);
    textSlider1.setDescription("y =");
    textSlider1.setModel(new BoundedRealModel(-5.0,0.0,5.0));
    textSlider1.setUnit("cm");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("\u03b1 =");
    textSlider2.setModel(new BoundedRealModel(-0.5,0.0,0.5));
    textSlider2.setUnit("\u03c0");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("r =");
    textSlider3.setModel(new BoundedRealModel(-20.0,-5.0,20.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    jPanel1.add(inputPanel1);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(2.0);
    layeredScreen1.setMinX(-10.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 20));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void sphericalMirrorView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_sphericalMirrorView1SourceChanged
    layeredScreen1.addView(sphericalMirrorView1);
    layeredScreen1.addView(planeLightSourceView1);
  }//GEN-LAST:event_sphericalMirrorView1SourceChanged
  
  private void planeLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSource1SourceChanged
    planeLightSourceView1.setModel(planeLightSource1);
    sphericalMirror1.propagate(planeLightSource1.getRays());
  }//GEN-LAST:event_planeLightSource1SourceChanged
  
  private void sphericalMirror1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_sphericalMirror1SourceChanged1
    planeLightSource1.trigger();
  }//GEN-LAST:event_sphericalMirror1SourceChanged1
  
  private void sphericalMirror1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_sphericalMirror1SourceChanged
    sphericalMirrorView1.setModel(sphericalMirror1);
  }//GEN-LAST:event_sphericalMirror1SourceChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    sphericalMirror1.setRadius(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    planeLightSource1.setAngle(textSlider2.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    planeLightSource1.setHeight(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PlaneLightSource planeLightSource1;
  protected physbeans.views.PlaneLightSourceView planeLightSourceView1;
  protected physbeans.phys.SphericalMirror sphericalMirror1;
  protected physbeans.views.SphericalMirrorView sphericalMirrorView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
