package physapps.quantummechanics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class FreeParticleUncertainty extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new FreeParticleUncertainty(), 540, 535);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    schroedinger2DPML1 = new physbeans.phys.Schroedinger2DPML();
    gaussianGridInitializer1 = new physbeans.phys.GaussianGridInitializer();
    jetColorTable1 = new physbeans.views.JetColorTable();
    complexGridView1 = new physbeans.views.ComplexGridView();
    meanValueObserver1 = new physbeans.phys.MeanValueObserver();
    vectorGain1 = new physbeans.func.VectorGain();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSlider1 = new physbeans.inout.VectorSlider();
    vectorSlider2 = new physbeans.inout.VectorSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    schroedinger2DPML1.setXMax(8.0E-9);
    schroedinger2DPML1.setXMin(-8.0E-9);
    schroedinger2DPML1.setYMax(8.0E-9);
    schroedinger2DPML1.setYMin(-8.0E-9);
    schroedinger2DPML1.setInitFunction(gaussianGridInitializer1);
    schroedinger2DPML1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        schroedinger2DPML1SourceChanged(evt);
        schroedinger2DPML1SourceChanged1(evt);
      }
    });

    complexGridView1.setColors(jetColorTable1);
    complexGridView1.setDepth(60);
    complexGridView1.setMaxVal(2.0E8);
    complexGridView1.setMinVal(-2.0E8);
    complexGridView1.setType(ComplexToRealEnum.ABS2);
    complexGridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        complexGridView1SourceChanged(evt);
      }
    });

    meanValueObserver1.setAutoTriggered(false);
    meanValueObserver1.setComputeUncertainties(true);
    meanValueObserver1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        meanValueObserver1ValueChanged(evt);
      }
    });

    vectorGain1.setGain(DVector.valueOf("[1.0E9,1.0E9,1.0E25,1.0E25]"));
    vectorGain1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        vectorGain1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(106, 300));
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(8.0E-9);
    layeredScreen1.setMinX(-8.0E-9);
    layeredScreen1.setViewActive(new boolean[] {true, false});
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(316, 200));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    oscilloscope1.setNLines(4);
    oscilloscope1.setAutomaticBufferSize(false);
    oscilloscope1.setBufferSize(150);
    oscilloscope1.setLineActive(new boolean[] {true, false, true, false});
    oscilloscope1.setMaxY(2.6);
    oscilloscope1.setMinY(0.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.quantummechanics.FreeParticleUncertainty", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    oscilloscope1.setTimePerTick(3.3843375603248805E-16);
    outputPanel.add(oscilloscope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSlider1.setColumns(7);
    vectorSlider1.setCount(2);
    vectorSlider1.setDescription("x0 =");
    vectorSlider1.setInitialValues(DVector.valueOf("[-1.0E-9,0.0]"));
    vectorSlider1.setMaximum(4.0E-9);
    vectorSlider1.setMinimum(-4.0E-9);
    vectorSlider1.setUnit("m");
    vectorSlider1.setVertical(false);
    vectorSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider1PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSlider1);

    vectorSlider2.setColumns(6);
    vectorSlider2.setCount(2);
    vectorSlider2.setDescription("v0 =");
    vectorSlider2.setInitialValues(DVector.valueOf("[300000.0,0.0]"));
    vectorSlider2.setMaximum(500000.0);
    vectorSlider2.setMinimum(-500000.0);
    vectorSlider2.setUnit("m/s");
    vectorSlider2.setVertical(false);
    vectorSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider2PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSlider2);

    textSlider1.setColumns(6);
    textSlider1.setDescription("s =");
    textSlider1.setModel(new BoundedRealModel(1.0E-10,2.0E-9,4.0E-9));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel.add(textSlider1);

    switchBox1.setBoxLabel(new String[] {"\u0394x  [10\u207b\u2079 m]", "\u0394y  [10\u207b\u2079 m]", "\u0394px  [10\u207b\u00b2\u2075 kg m/s]", "\u0394py [10\u207b\u00b2\u2075 kg m/s]"});
    switchBox1.setSelected(new boolean[] {true, false, true, false});
    switchBox1.setTitle(bundle.getString("osciShows")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    schroedinger2DPML1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    schroedinger2DPML1.restart();
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart

  private void vectorSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange
    gaussianGridInitializer1.setX0(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange

  private void vectorSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider2PropertyChange
    gaussianGridInitializer1.setV0(vectorSlider2.getValue());
  }//GEN-LAST:event_vectorSlider2PropertyChange

  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    gaussianGridInitializer1.setWidth(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange

  private void complexGridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_complexGridView1SourceChanged
    layeredScreen1.addView(complexGridView1);
  }//GEN-LAST:event_complexGridView1SourceChanged

  private void schroedinger2DPML1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2DPML1SourceChanged
    complexGridView1.setModel(schroedinger2DPML1);
  }//GEN-LAST:event_schroedinger2DPML1SourceChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void schroedinger2DPML1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2DPML1SourceChanged1
    meanValueObserver1.setWaveFunction(schroedinger2DPML1);
  }//GEN-LAST:event_schroedinger2DPML1SourceChanged1

  private void meanValueObserver1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_meanValueObserver1ValueChanged
    vectorGain1.setInputVector(meanValueObserver1.getUncertainties());
  }//GEN-LAST:event_meanValueObserver1ValueChanged

  private void vectorGain1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_vectorGain1ValueChanged
    oscilloscope1.setInputVector(vectorGain1.getOutputVector());
  }//GEN-LAST:event_vectorGain1ValueChanged

  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    meanValueObserver1.trigger();
  }//GEN-LAST:event_timer1NextStep1

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.ComplexGridView complexGridView1;
  protected physbeans.phys.GaussianGridInitializer gaussianGridInitializer1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.JetColorTable jetColorTable1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.MeanValueObserver meanValueObserver1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.phys.Schroedinger2DPML schroedinger2DPML1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.func.VectorGain vectorGain1;
  protected physbeans.inout.VectorSlider vectorSlider1;
  protected physbeans.inout.VectorSlider vectorSlider2;
  // End of variables declaration//GEN-END:variables
}
