package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.phys.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class DieselCycle extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new DieselCycle(), 560, 470);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    cyclicProcess1 = new physbeans.phys.CyclicProcess();
    perfectGas1 = new physbeans.phys.PerfectGas();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    arithmeticFunction2 = new physbeans.func.ArithmeticFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    multiplexer2 = new physbeans.func.Multiplexer();
    multiplexer3 = new physbeans.func.Multiplexer();
    cylinderView1 = new physbeans.views.CylinderView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderP1 = new physbeans.inout.TextSlider();
    textSliderV1 = new physbeans.inout.TextSlider();
    textSliderEps = new physbeans.inout.TextSlider();
    textSliderPhi = new physbeans.inout.TextSlider();
    
    cyclicProcess1.setNSteps(new int[]{80,20,80,20});
    cyclicProcess1.setPoints(DVector.valueOf("[0.0,0.0,0.0]"));
    cyclicProcess1.setPolytropicExponents(DVector.valueOf("[1.4,0.0,1.4,Infinity]"));
    cyclicProcess1.setSystem(perfectGas1);
    perfectGas1.setMass(0.0020);
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
        perfectGas1SourceChanged2(evt);
      }
    });
    
    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
        arithmeticFunction1ValueChanged1(evt);
      }
    });
    
    arithmeticFunction2.setFirstOp(2);
    arithmeticFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction2ValueChanged(evt);
      }
    });
    
    multiplexer1.setAutoTriggered(false);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    multiplexer2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer2ValueChanged(evt);
      }
    });
    
    multiplexer3.setCollectInput(false);
    multiplexer3.setInputLength(3);
    multiplexer3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer3ValueChanged(evt);
      }
    });
    
    cylinderView1.setTMax(1500.0);
    cylinderView1.setTMin(300.0);
    cylinderView1.setInitialValues(DVector.valueOf("[1.435,1000.0]"));
    cylinderView1.setMaxVolume(0.0025);
    cylinderView1.setPistonDiameter(0.03);
    cylinderView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        cylinderView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    numericTextField1.setDescription("T =");
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(4);
    numericTextField1.setUnit("K");
    objectPanel1.add(numericTextField1, java.awt.BorderLayout.SOUTH);
    
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setMaxX(1.2);
    layeredScreen1.setMaxY(0.8);
    layeredScreen1.setMinX(-0.2);
    layeredScreen1.setMinY(-0.8);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(0.0025);
    xYScope1.setMaxY(7000000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.DieselCycle", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.DieselCycle", currentLocale).getString("osciScale"));
    xYScope1.setShowMarker(true);
    outputPanel1.add(xYScope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(30L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.thermodynamics.DieselCycle", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSliderP1.setDescription("p1 =");
    textSliderP1.setModel(new BoundedRealModel(10000.0,100000.0,600000.0));
    textSliderP1.setUnit("Pa");
    textSliderP1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderP1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSliderP1);
    
    textSliderV1.setDescription("V1 =");
    textSliderV1.setModel(new BoundedRealModel(2.0E-4,0.0020,0.0025));
    textSliderV1.setUnit("m\u00b3");
    textSliderV1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderV1PropertyChange(evt);
        textSliderV1PropertyChange1(evt);
      }
    });
    
    inputPanel1.add(textSliderV1);
    
    textSliderEps.setDescription("\u03b5 =");
    textSliderEps.setModel(new BoundedRealModel(1.0,18.0,30.0));
    textSliderEps.setUnit("");
    textSliderEps.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderEpsPropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSliderEps);
    
    textSliderPhi.setDescription("\u03c6 =");
    textSliderPhi.setModel(new BoundedRealModel(1.0,1.808,5.0));
    textSliderPhi.setUnit("");
    textSliderPhi.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderPhiPropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSliderPhi);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void cylinderView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_cylinderView1SourceChanged
    layeredScreen1.addView(cylinderView1);
  }//GEN-LAST:event_cylinderView1SourceChanged
  
  private void arithmeticFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction2ValueChanged
    multiplexer3.setInputValues(2, arithmeticFunction2.getResult());
  }//GEN-LAST:event_arithmeticFunction2ValueChanged
  
  private void textSliderPhiPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderPhiPropertyChange
    arithmeticFunction2.setSecondArg(textSliderPhi.getValue());
  }//GEN-LAST:event_textSliderPhiPropertyChange
  
  private void arithmeticFunction1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged1
    arithmeticFunction2.setFirstArg(arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged1
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    multiplexer3.setInputValues(1, arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void textSliderEpsPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderEpsPropertyChange
    arithmeticFunction1.setSecondArg(textSliderEps.getValue());
  }//GEN-LAST:event_textSliderEpsPropertyChange
  
  private void textSliderV1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV1PropertyChange1
    arithmeticFunction1.setFirstArg(textSliderV1.getValue());
  }//GEN-LAST:event_textSliderV1PropertyChange1
  
  private void multiplexer2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer2ValueChanged
    cylinderView1.setModel(multiplexer2.getOutputVector());
  }//GEN-LAST:event_multiplexer2ValueChanged
  
  private void perfectGas1SourceChanged2(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged2
    numericTextField1.setValue(perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged2
  
  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    multiplexer2.setInputValues(0, perfectGas1.getVolume());
    multiplexer2.setInputValues(1, perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged1
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    xYScope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    multiplexer1.setInputValues(0, perfectGas1.getVolume());
    multiplexer1.setInputValues(1, perfectGas1.getPressure());
  }//GEN-LAST:event_perfectGas1SourceChanged
  
  private void multiplexer3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer3ValueChanged
    cyclicProcess1.setPoints(multiplexer3.getOutputVector());
  }//GEN-LAST:event_multiplexer3ValueChanged
  
  private void textSliderV1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV1PropertyChange
    multiplexer3.setInputValues(0, textSliderV1.getValue());
  }//GEN-LAST:event_textSliderV1PropertyChange
  
  private void textSliderP1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderP1PropertyChange
    cyclicProcess1.setStartPressure(textSliderP1.getValue());
  }//GEN-LAST:event_textSliderP1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    cyclicProcess1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    cyclicProcess1.nextStep();
    multiplexer1.trigger();
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.ArithmeticFunction arithmeticFunction2;
  protected physbeans.phys.CyclicProcess cyclicProcess1;
  protected physbeans.views.CylinderView cylinderView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.func.Multiplexer multiplexer2;
  protected physbeans.func.Multiplexer multiplexer3;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.TextSlider textSliderEps;
  protected physbeans.inout.TextSlider textSliderP1;
  protected physbeans.inout.TextSlider textSliderPhi;
  protected physbeans.inout.TextSlider textSliderV1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
// End of variables declaration//GEN-END:variables
  
}
