package physapps.thermodynamics;

import physbeans.math.*;
import physbeans.model.*;
import physbeans.inout.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class HeatResistance extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new HeatResistance(), 560, 350);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    layeredTemperatureField1 = new physbeans.phys.LayeredTemperatureField();
    gridView1 = new physbeans.views.GridView();
    heatColorTable1 = new physbeans.views.HeatColorTable();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    simpleFigureView2 = new physbeans.views.SimpleFigureView();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    arithmeticFunction2 = new physbeans.func.ArithmeticFunction();
    arrowView1 = new physbeans.views.ArrowView();
    scalingFunction1 = new physbeans.func.ScalingFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextField1 = new physbeans.inout.NumericTextField();
    numericTextField2 = new physbeans.inout.NumericTextField();
    numericTextField3 = new physbeans.inout.NumericTextField();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();

    layeredTemperatureField1.setGridSizeX(330);
    layeredTemperatureField1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        layeredTemperatureField1SourceChanged(evt);
      }
    });
    layeredTemperatureField1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredTemperatureField1ValueChanged(evt);
      }
    });

    gridView1.setColors(heatColorTable1);
    gridView1.setDepth(70);
    gridView1.setMaxVal(293.0);
    gridView1.setMinVal(273.0);
    gridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        gridView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setDepth(60);
    simpleFigureView1.setFigureType(1);
    simpleFigureView1.setP1(DVector.valueOf("[0.0,-1.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    simpleFigureView2.setFigureType(1);
    simpleFigureView2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView2SourceChanged(evt);
      }
    });

    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });

    arithmeticFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction2ValueChanged(evt);
      }
    });

    arrowView1.setArrowLength(0.65);
    arrowView1.setDepth(40);
    arrowView1.setX(-0.1);
    arrowView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        arrowView1SourceChanged(evt);
      }
    });

    scalingFunction1.setXMax(1000000.0);
    scalingFunction1.setXMin(0.3);
    scalingFunction1.setYMax(1.0);
    scalingFunction1.setLogarithmic(true);
    scalingFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        scalingFunction1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new java.awt.BorderLayout());

    objectPanel1.setBordered(true);

    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setMaxX(0.65);
    layeredScreen1.setMinX(-0.2);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);

    numericTextField1.setBordered(true);
    numericTextField1.setColumns(5);
    numericTextField1.setDescription("\u03a6 =");
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(4);
    numericTextField1.setUnit("W/m\u00b2");
    outputPanel1.add(numericTextField1);

    numericTextField2.setBordered(true);
    numericTextField2.setColumns(5);
    numericTextField2.setDescription("x =");
    numericTextField2.setEditable(false);
    numericTextField2.setUnit("m");
    outputPanel1.add(numericTextField2);

    numericTextField3.setBordered(true);
    numericTextField3.setColumns(5);
    numericTextField3.setDescription("T =");
    numericTextField3.setEditable(false);
    numericTextField3.setPrecision(5);
    numericTextField3.setUnit("K");
    outputPanel1.add(numericTextField3);

    jPanel2.add(outputPanel1, java.awt.BorderLayout.SOUTH);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    textSlider1.setDescription("d1 =");
    textSlider1.setModel(new BoundedRealModel(0.0,0.1,0.2));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("d2 =");
    textSlider2.setModel(new BoundedRealModel(0.0,0.1,0.2));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("d3 =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.1,0.2));
    textSlider3.setUnit("m");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider4.setDescription("\u03bb1 =");
    textSlider4.setLogarithmic(true);
    textSlider4.setModel(new BoundedRealModel(0.01,10.0,10000.0));
    textSlider4.setUnit("W/(K*m)");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider5.setDescription("\u03bb2 =");
    textSlider5.setLogarithmic(true);
    textSlider5.setModel(new BoundedRealModel(0.01,10.0,10000.0));
    textSlider5.setUnit("W/(K*m)");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider5);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void layeredTemperatureField1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredTemperatureField1ValueChanged
    numericTextField3.setValue(layeredTemperatureField1.getLastScalarValue());
  }//GEN-LAST:event_layeredTemperatureField1ValueChanged

  private void arrowView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_arrowView1SourceChanged
    layeredScreen1.addView(arrowView1);
  }//GEN-LAST:event_arrowView1SourceChanged

  private void simpleFigureView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView2SourceChanged
    layeredScreen1.addView(simpleFigureView2);
  }//GEN-LAST:event_simpleFigureView2SourceChanged

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void gridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_gridView1SourceChanged
    layeredScreen1.addView(gridView1);
  }//GEN-LAST:event_gridView1SourceChanged

  private void scalingFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_scalingFunction1ValueChanged
    arrowView1.setArrowWidth(scalingFunction1.getOutputValue());
  }//GEN-LAST:event_scalingFunction1ValueChanged

  private void layeredTemperatureField1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_layeredTemperatureField1SourceChanged
    double val = layeredTemperatureField1.getPhi();
    scalingFunction1.setInputValue(val);
    numericTextField1.setValue(val);
    gridView1.setModel(layeredTemperatureField1);
  }//GEN-LAST:event_layeredTemperatureField1SourceChanged

  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    DVector vec = layeredScreen1.getClickedPosition();
    layeredTemperatureField1.sendScalarValue(vec);
    numericTextField2.setValueFromVector(vec, 0);
  }//GEN-LAST:event_layeredScreen1ValueChanged
            
  private void arithmeticFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction2ValueChanged
    double val = arithmeticFunction2.getResult();
    simpleFigureView2.setP3(new DVector(val, -1.0));
    simpleFigureView2.setP4(new DVector(val, 1.0));
  }//GEN-LAST:event_arithmeticFunction2ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    double val = arithmeticFunction1.getResult();
    arithmeticFunction2.setFirstArg(val);
    simpleFigureView2.setP1(new DVector(val, -1.0));
    simpleFigureView2.setP2(new DVector(val, 1.0));
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
    
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    layeredTemperatureField1.setLambda2(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    layeredTemperatureField1.setLambda1(val);
    layeredTemperatureField1.setLambda3(val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    layeredTemperatureField1.setD3(val);
    arithmeticFunction2.setSecondArg(val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    layeredTemperatureField1.setD2(val);
    arithmeticFunction1.setSecondArg(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    layeredTemperatureField1.setD1(val);
    simpleFigureView1.setP3(new DVector(val, -1.0));
    simpleFigureView1.setP4(new DVector(val, 1.0));
    arithmeticFunction1.setFirstArg(val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.ArithmeticFunction arithmeticFunction2;
  protected physbeans.views.ArrowView arrowView1;
  protected physbeans.views.GridView gridView1;
  protected physbeans.views.HeatColorTable heatColorTable1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LayeredTemperatureField layeredTemperatureField1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.NumericTextField numericTextField2;
  protected physbeans.inout.NumericTextField numericTextField3;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.ScalingFunction scalingFunction1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.views.SimpleFigureView simpleFigureView2;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  // End of variables declaration//GEN-END:variables
  
}
