package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;

/**
 * base class of all simple computation applets <br>
 * contains an input and an output panel<br>
 *
 */
public class HeatTransition extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new HeatTransition(), 440, 260);
  }
  
  /** Creates new form PhysicsApplet */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    checkedFunction1 = new physbeans.func.CheckedFunction();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    numericTextLine1 = new physbeans.inout.NumericTextLine();
    numericTextLine2 = new physbeans.inout.NumericTextLine();
    numericTextLine3 = new physbeans.inout.NumericTextLine();
    numericTextLine4 = new physbeans.inout.NumericTextLine();
    numericTextLine5 = new physbeans.inout.NumericTextLine();
    outputPanel1 = new physbeans.inout.OutputPanel();
    numericTextLine6 = new physbeans.inout.NumericTextLine();
    numericTextLine7 = new physbeans.inout.NumericTextLine();
    numericTextLine8 = new physbeans.inout.NumericTextLine();
    
    checkedFunction1.setCheckString("(d1 > 0) & (d2 > 0) & (l1 > 0) & (l2 > 0) & (a > 0)");
    checkedFunction1.setFunction(new String[] {"20.0/(2*d1/l1 + d2/l2 + 2.0/a)", "phi*(d1/l1 + 1.0/a); phi: 20.0/(2*d1/l1 + d2/l2 + 2.0/a)", "phi*(d1/l1 + d2/l2 + 1.0/a); phi: 20.0/(2*d1/l1 + d2/l2 + 2.0/a)"});
    checkedFunction1.setVariableName(new String[] {"d1", "d2", "l1", "l2", "a"});
    checkedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        checkedFunction1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    numericTextLine1.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s2"));
    numericTextLine1.setOffset(70);
    numericTextLine1.setPrecision(5);
    numericTextLine1.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s1"));
    numericTextLine1.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s3"));
    numericTextLine1.setValue(0.09);
    numericTextLine1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine1PropertyChange(evt);
      }
    });
    numericTextLine1.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine1VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine1);
    
    numericTextLine2.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s5"));
    numericTextLine2.setOffset(70);
    numericTextLine2.setPrecision(5);
    numericTextLine2.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s4"));
    numericTextLine2.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s6"));
    numericTextLine2.setValue(0.05);
    numericTextLine2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine2PropertyChange(evt);
      }
    });
    numericTextLine2.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine2VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine2);
    
    numericTextLine3.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s8"));
    numericTextLine3.setOffset(70);
    numericTextLine3.setPrecision(5);
    numericTextLine3.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s7"));
    numericTextLine3.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s9"));
    numericTextLine3.setValue(100.0);
    numericTextLine3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine3PropertyChange(evt);
      }
    });
    numericTextLine3.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine3VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine3);
    
    numericTextLine4.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s11"));
    numericTextLine4.setOffset(70);
    numericTextLine4.setPrecision(5);
    numericTextLine4.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s10"));
    numericTextLine4.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s12"));
    numericTextLine4.setValue(0.042);
    numericTextLine4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine4PropertyChange(evt);
      }
    });
    numericTextLine4.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine4VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine4);
    
    numericTextLine5.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s14"));
    numericTextLine5.setOffset(70);
    numericTextLine5.setPrecision(5);
    numericTextLine5.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s13"));
    numericTextLine5.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s15"));
    numericTextLine5.setValue(6.2);
    numericTextLine5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        numericTextLine5PropertyChange(evt);
      }
    });
    numericTextLine5.addVetoableChangeListener(new java.beans.VetoableChangeListener() {
      public void vetoableChange(java.beans.PropertyChangeEvent evt)throws java.beans.PropertyVetoException {
        numericTextLine5VetoableChange(evt);
      }
    });
    
    inputPanel1.add(numericTextLine5);
    
    jPanel1.add(inputPanel1);
    
    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    numericTextLine6.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s17"));
    numericTextLine6.setEditable(false);
    numericTextLine6.setOffset(70);
    numericTextLine6.setPrecision(5);
    numericTextLine6.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s16"));
    numericTextLine6.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s18"));
    outputPanel1.add(numericTextLine6);
    
    numericTextLine7.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s20"));
    numericTextLine7.setEditable(false);
    numericTextLine7.setOffset(70);
    numericTextLine7.setPrecision(5);
    numericTextLine7.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s19"));
    numericTextLine7.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s21"));
    outputPanel1.add(numericTextLine7);
    
    numericTextLine8.setDescription(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s23"));
    numericTextLine8.setEditable(false);
    numericTextLine8.setOffset(70);
    numericTextLine8.setPrecision(5);
    numericTextLine8.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s22"));
    numericTextLine8.setUnit(java.util.ResourceBundle.getBundle("physapps.thermodynamics.HeatTransition", currentLocale).getString("s24"));
    outputPanel1.add(numericTextLine8);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }
// </editor-fold>//GEN-END:initComponents
  
  private void checkedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_checkedFunction1ValueChanged
    numericTextLine6.setValue(checkedFunction1.getOutputValues(0));
    numericTextLine7.setValue(checkedFunction1.getOutputValues(1));
    numericTextLine8.setValue(checkedFunction1.getOutputValues(2));
  }//GEN-LAST:event_checkedFunction1ValueChanged
    
  private void numericTextLine5VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine5VetoableChange
    checkedFunction1.checkValue(4, evt);
  }//GEN-LAST:event_numericTextLine5VetoableChange
  
  private void numericTextLine4VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine4VetoableChange
    checkedFunction1.checkValue(3, evt);
  }//GEN-LAST:event_numericTextLine4VetoableChange
  
  private void numericTextLine3VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine3VetoableChange
    checkedFunction1.checkValue(2, evt);
  }//GEN-LAST:event_numericTextLine3VetoableChange
  
  private void numericTextLine2VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine2VetoableChange
    checkedFunction1.checkValue(1, evt);
  }//GEN-LAST:event_numericTextLine2VetoableChange
  
  private void numericTextLine1VetoableChange(java.beans.PropertyChangeEvent evt) throws java.beans.PropertyVetoException {//GEN-FIRST:event_numericTextLine1VetoableChange
    checkedFunction1.checkValue(0, evt);
  }//GEN-LAST:event_numericTextLine1VetoableChange
  
  private void numericTextLine5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine5PropertyChange
    checkedFunction1.singleInputValue(4, numericTextLine5.getValue());
  }//GEN-LAST:event_numericTextLine5PropertyChange
  
  private void numericTextLine4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine4PropertyChange
    checkedFunction1.singleInputValue(3, numericTextLine4.getValue());
  }//GEN-LAST:event_numericTextLine4PropertyChange
  
  private void numericTextLine3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine3PropertyChange
    checkedFunction1.singleInputValue(2, numericTextLine3.getValue());
  }//GEN-LAST:event_numericTextLine3PropertyChange
  
  private void numericTextLine2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine2PropertyChange
    checkedFunction1.singleInputValue(1, numericTextLine2.getValue());
  }//GEN-LAST:event_numericTextLine2PropertyChange
  
  private void numericTextLine1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_numericTextLine1PropertyChange
    checkedFunction1.singleInputValue(0, numericTextLine1.getValue());
  }//GEN-LAST:event_numericTextLine1PropertyChange
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.CheckedFunction checkedFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.NumericTextLine numericTextLine1;
  protected physbeans.inout.NumericTextLine numericTextLine2;
  protected physbeans.inout.NumericTextLine numericTextLine3;
  protected physbeans.inout.NumericTextLine numericTextLine4;
  protected physbeans.inout.NumericTextLine numericTextLine5;
  protected physbeans.inout.NumericTextLine numericTextLine6;
  protected physbeans.inout.NumericTextLine numericTextLine7;
  protected physbeans.inout.NumericTextLine numericTextLine8;
  protected physbeans.inout.OutputPanel outputPanel1;
// End of variables declaration//GEN-END:variables
  
}
