package physapps.thermodynamics;

import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class IsexCycle extends physbeans.inout.PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new IsexCycle(), 830, 585);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    cyclicProcess1 = new physbeans.phys.CyclicProcess();
    perfectGas1 = new physbeans.phys.PerfectGas();
    arithmeticFunctionV1 = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV1a = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV1b = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV1c = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV1d = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV2 = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV3 = new physbeans.func.ArithmeticFunction();
    arithmeticFunctionV3a = new physbeans.func.ArithmeticFunction();
    parsedFunctionV3b = new physbeans.func.ParsedFunction();
    allVMux = new physbeans.func.Multiplexer();
    isexViewMux = new physbeans.func.Multiplexer();
    isexView1 = new physbeans.views.IsexView();
    barViewMux = new physbeans.func.Multiplexer();
    barView1 = new physbeans.views.BarView();
    labelView1 = new physbeans.views.LabelView();
    labelView2 = new physbeans.views.LabelView();
    pVScopeMux = new physbeans.func.Multiplexer();
    tSScopeMux = new physbeans.func.Multiplexer();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    physicsPanel1 = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    numericTextField1 = new physbeans.inout.NumericTextField();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    xYScope1 = new physbeans.inout.XYScope();
    xYScope2 = new physbeans.inout.XYScope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderP1 = new physbeans.inout.TextSlider();
    textSliderT1 = new physbeans.inout.TextSlider();
    textSliderEps = new physbeans.inout.TextSlider();
    textSliderEpsa = new physbeans.inout.TextSlider();
    textSliderEpsb = new physbeans.inout.TextSlider();
    textSliderT3 = new physbeans.inout.TextSlider();
    textSliderEpst = new physbeans.inout.TextSlider();
    textSliderQt = new physbeans.inout.TextSlider();

    cyclicProcess1.setNStates(10);
    cyclicProcess1.setNSteps(new int[]{100,30,100,30,100,100,100,50,100,100});
    cyclicProcess1.setPoints(DVector.valueOf("[0.8697,0.4316,0.3261,0.2306,0.2007,0.1591,0.4415,0.6489,0.8938]"));
    cyclicProcess1.setPolytropicExponents(DVector.valueOf("[1.4,0.0,1.4,0.0,1.4,0.0,1.4,0.0,1.4,0.0]"));
    cyclicProcess1.setStartPressure(100000.0);
    cyclicProcess1.setSystem(perfectGas1);
    cyclicProcess1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        cyclicProcess1SourceChanged(evt);
      }
    });

    perfectGas1.setAutoReset(false);
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
      }
    });

    arithmeticFunctionV1.setFirstArg(287.0168894);
    arithmeticFunctionV1.setFirstOp(2);
    arithmeticFunctionV1.setSecondOp(3);
    arithmeticFunctionV1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV1ValueChanged(evt);
      }
    });

    arithmeticFunctionV1a.setAssociativity(2);
    arithmeticFunctionV1a.setFirstOp(3);
    arithmeticFunctionV1a.setSecondOp(5);
    arithmeticFunctionV1a.setThirdArg(0.714285714);
    arithmeticFunctionV1a.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV1aValueChanged(evt);
      }
    });

    arithmeticFunctionV1b.setAssociativity(1);
    arithmeticFunctionV1b.setFirstArg(287.0168894);
    arithmeticFunctionV1b.setFirstOp(2);
    arithmeticFunctionV1b.setSecondOp(3);
    arithmeticFunctionV1b.setThirdOp(2);
    arithmeticFunctionV1b.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV1bValueChanged(evt);
      }
    });

    arithmeticFunctionV1c.setAssociativity(3);
    arithmeticFunctionV1c.setFirstOp(2);
    arithmeticFunctionV1c.setFourthArg(0.714285714);
    arithmeticFunctionV1c.setSecondOp(3);
    arithmeticFunctionV1c.setThirdOp(5);
    arithmeticFunctionV1c.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV1cValueChanged(evt);
      }
    });

    arithmeticFunctionV1d.setAssociativity(1);
    arithmeticFunctionV1d.setFirstArg(287.0168894);
    arithmeticFunctionV1d.setFirstOp(2);
    arithmeticFunctionV1d.setSecondOp(3);
    arithmeticFunctionV1d.setThirdOp(2);
    arithmeticFunctionV1d.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV1dValueChanged(evt);
      }
    });

    arithmeticFunctionV2.setAssociativity(3);
    arithmeticFunctionV2.setFirstOp(2);
    arithmeticFunctionV2.setFourthArg(0.714285714);
    arithmeticFunctionV2.setSecondOp(3);
    arithmeticFunctionV2.setThirdOp(5);
    arithmeticFunctionV2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV2ValueChanged(evt);
      }
    });

    arithmeticFunctionV3.setAssociativity(1);
    arithmeticFunctionV3.setFirstArg(287.0168894);
    arithmeticFunctionV3.setFirstOp(2);
    arithmeticFunctionV3.setSecondOp(3);
    arithmeticFunctionV3.setThirdOp(2);
    arithmeticFunctionV3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV3ValueChanged(evt);
      }
    });

    arithmeticFunctionV3a.setAssociativity(3);
    arithmeticFunctionV3a.setFirstOp(2);
    arithmeticFunctionV3a.setFourthArg(0.714285714);
    arithmeticFunctionV3a.setSecondOp(3);
    arithmeticFunctionV3a.setThirdOp(5);
    arithmeticFunctionV3a.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunctionV3aValueChanged(evt);
      }
    });

    parsedFunctionV3b.setFunction(new String[] {"V3a + (ka - 1)/ka * Qt/(epst*p1)"});
    parsedFunctionV3b.setParameter(DVector.valueOf("[1.4]"));
    parsedFunctionV3b.setVariableName(new String[] {"V3a", "Qt", "epst", "p1", "ka"});
    parsedFunctionV3b.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunctionV3bValueChanged(evt);
      }
    });

    allVMux.setCollectInput(false);
    allVMux.setInputLength(9);
    allVMux.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        allVMuxValueChanged(evt);
      }
    });

    isexViewMux.setCollectInput(false);
    isexViewMux.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        isexViewMuxValueChanged(evt);
      }
    });

    isexView1.setTMax(1100.0);
    isexView1.setTMin(300.0);
    isexView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        isexView1SourceChanged(evt);
      }
    });

    barViewMux.setCollectInput(false);
    barViewMux.setInputLength(5);
    barViewMux.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        barViewMuxValueChanged(evt);
      }
    });

    barView1.setEqualBarColor(false);
    barView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        barView1SourceChanged(evt);
      }
    });

    labelView1.setDepth(40);
    labelView1.setMarginLeft(0.0);
    labelView1.setMarginRight(0.0);
    labelView1.setPrecision(3);
    labelView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView1SourceChanged(evt);
      }
    });

    labelView2.setDepth(41);
    labelView2.setInitialValues(new String[] {"U", "Wv", "Q", "Wt", "H"});
    labelView2.setMarginLeft(0.0);
    labelView2.setMarginRight(0.0);
    labelView2.setPosition(1.0);
    labelView2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView2SourceChanged(evt);
      }
    });

    pVScopeMux.setAutoTriggered(false);
    pVScopeMux.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        pVScopeMuxValueChanged(evt);
      }
    });

    tSScopeMux.setAutoTriggered(false);
    tSScopeMux.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        tSScopeMuxValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new javax.swing.BoxLayout(objectPanel, javax.swing.BoxLayout.LINE_AXIS));

    physicsPanel1.setBackground(new java.awt.Color(255, 255, 175));
    physicsPanel1.setBordered(true);
    physicsPanel1.setPreferredSize(new java.awt.Dimension(300, 100));
    physicsPanel1.setLayout(new java.awt.BorderLayout(0, 6));

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setMaxX(5.0);
    layeredScreen1.setMaxY(5.0);
    layeredScreen1.setMinY(-0.5);
    layeredScreen1.setOpaque(true);
    physicsPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    numericTextField1.setDescription("T =");
    numericTextField1.setUnit("K");
    physicsPanel1.add(numericTextField1, java.awt.BorderLayout.SOUTH);

    objectPanel.add(physicsPanel1);

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(4.85);
    controlledLayeredScreen1.setMaxY(1000000.0);
    controlledLayeredScreen1.setMinX(-0.15);
    controlledLayeredScreen1.setMinY(-500000.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.thermodynamics.IsexCycle", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    controlledLayeredScreen1.setViewActive(new boolean[]{true,true,true});
    objectPanel.add(controlledLayeredScreen1);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(3.0);
    xYScope1.setMaxY(700000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    xYScope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    xYScope1.setShowMarker(true);
    outputPanel.add(xYScope1);

    xYScope2.setBufferSize(5000);
    xYScope2.setDotSize(6);
    xYScope2.setMaxX(1600.0);
    xYScope2.setMaxY(1600.0);
    xYScope2.setMinX(-400.0);
    xYScope2.setMinY(0.0);
    xYScope2.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    xYScope2.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    xYScope2.setShowMarker(true);
    outputPanel.add(xYScope2);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(20L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    textSliderP1.setDescription("p1 =");
    textSliderP1.setModel(new BoundedRealModel(50000.0,100000.0,600000.0));
    textSliderP1.setUnit("Pa");
    textSliderP1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderP1PropertyChange(evt);
      }
    });
    inputPanel.add(textSliderP1);

    textSliderT1.setDescription("T1 =");
    textSliderT1.setModel(new BoundedRealModel(250.0,303.0,500.0));
    textSliderT1.setUnit("K");
    textSliderT1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderT1PropertyChange(evt);
      }
    });
    inputPanel.add(textSliderT1);

    textSliderEps.setDescription("\u03b5 =");
    textSliderEps.setModel(new BoundedRealModel(1.0,6.0,12.0));
    textSliderEps.setUnit("");
    textSliderEps.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderEpsPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderEps);

    textSliderEpsa.setDescription("\u03b5a =");
    textSliderEpsa.setModel(new BoundedRealModel(1.0,2.667,12.0));
    textSliderEpsa.setUnit("");
    textSliderEpsa.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderEpsaPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderEpsa);

    textSliderEpsb.setDescription("\u03b5b =");
    textSliderEpsb.setModel(new BoundedRealModel(1.0,4.333,12.0));
    textSliderEpsb.setUnit("");
    textSliderEpsb.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderEpsbPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderEpsb);

    textSliderT3.setDescription("T3 =");
    textSliderT3.setModel(new BoundedRealModel(300.0,923.0,1500.0));
    textSliderT3.setUnit("K");
    textSliderT3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderT3PropertyChange(evt);
      }
    });
    inputPanel.add(textSliderT3);

    textSliderEpst.setDescription("\u03b5t =");
    textSliderEpst.setModel(new BoundedRealModel(1.0,3.5,12.0));
    textSliderEpst.setUnit("");
    textSliderEpst.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderEpstPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderEpst);

    textSliderQt.setDescription("Qt =");
    textSliderQt.setModel(new BoundedRealModel(0.0,300000.0,700000.0));
    textSliderQt.setUnit("J");
    textSliderQt.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderQtPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderQt);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void labelView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView2SourceChanged
    controlledLayeredScreen1.addView(labelView2);
  }//GEN-LAST:event_labelView2SourceChanged

  private void labelView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView1SourceChanged
    controlledLayeredScreen1.addView(labelView1);
  }//GEN-LAST:event_labelView1SourceChanged

  private void barView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged
    controlledLayeredScreen1.addView(barView1);
  }//GEN-LAST:event_barView1SourceChanged

  private void barViewMuxValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_barViewMuxValueChanged
    DVector vec = barViewMux.getOutputVector();
    barView1.setModel(vec);
    labelView1.setValues(vec);
  }//GEN-LAST:event_barViewMuxValueChanged

  private void tSScopeMuxValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_tSScopeMuxValueChanged
    xYScope2.setInputVector(tSScopeMux.getOutputVector());
  }//GEN-LAST:event_tSScopeMuxValueChanged

  private void isexView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_isexView1SourceChanged
    layeredScreen1.addView(isexView1);
  }//GEN-LAST:event_isexView1SourceChanged

  private void isexViewMuxValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_isexViewMuxValueChanged
    isexView1.setModel(isexViewMux.getOutputVector());
  }//GEN-LAST:event_isexViewMuxValueChanged

  private void cyclicProcess1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_cyclicProcess1SourceChanged
    isexViewMux.setInputValues(1, cyclicProcess1.getPhase());
  }//GEN-LAST:event_cyclicProcess1SourceChanged

  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    numericTextField1.setValue(perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged1

  private void allVMuxValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_allVMuxValueChanged
    cyclicProcess1.setPoints(allVMux.getOutputVector());
  }//GEN-LAST:event_allVMuxValueChanged
  
  private void parsedFunctionV3bValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunctionV3bValueChanged
    double val = parsedFunctionV3b.getOutputValue();
    allVMux.setInputValues(8, val);
  }//GEN-LAST:event_parsedFunctionV3bValueChanged
  
  private void textSliderQtPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderQtPropertyChange
    double val = textSliderQt.getValue();
    parsedFunctionV3b.singleInputValue(1, val);
  }//GEN-LAST:event_textSliderQtPropertyChange
  
  private void arithmeticFunctionV3aValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV3aValueChanged
    double val = arithmeticFunctionV3a.getResult();
    allVMux.setInputValues(7, val);
    parsedFunctionV3b.singleInputValue(0, val);
  }//GEN-LAST:event_arithmeticFunctionV3aValueChanged
  
  private void textSliderEpstPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderEpstPropertyChange
    double val = textSliderEpst.getValue();
    arithmeticFunctionV3a.setThirdArg(val);
    parsedFunctionV3b.singleInputValue(2, val);
  }//GEN-LAST:event_textSliderEpstPropertyChange
  
  private void arithmeticFunctionV3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV3ValueChanged
    double val = arithmeticFunctionV3.getResult();
    allVMux.setInputValues(6, val);
    arithmeticFunctionV3a.setFirstArg(val);
  }//GEN-LAST:event_arithmeticFunctionV3ValueChanged
  
  private void textSliderT3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderT3PropertyChange
    double val = textSliderT3.getValue();
    arithmeticFunctionV3.setSecondArg(val);
  }//GEN-LAST:event_textSliderT3PropertyChange
  
  private void arithmeticFunctionV2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV2ValueChanged
    double val = arithmeticFunctionV2.getResult();
    allVMux.setInputValues(5, val);
  }//GEN-LAST:event_arithmeticFunctionV2ValueChanged
  
  private void textSliderEpsPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderEpsPropertyChange
    double val = textSliderEps.getValue();
    arithmeticFunctionV2.setThirdArg(val);
    arithmeticFunctionV3.setFourthArg(val);
    arithmeticFunctionV3a.setSecondArg(val);
  }//GEN-LAST:event_textSliderEpsPropertyChange
  
  private void arithmeticFunctionV1dValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV1dValueChanged
    double val = arithmeticFunctionV1d.getResult();
    allVMux.setInputValues(4, val);
    arithmeticFunctionV2.setFirstArg(val);
  }//GEN-LAST:event_arithmeticFunctionV1dValueChanged
  
  private void arithmeticFunctionV1cValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV1cValueChanged
    double val = arithmeticFunctionV1c.getResult();
    allVMux.setInputValues(3, val);
  }//GEN-LAST:event_arithmeticFunctionV1cValueChanged
  
  private void textSliderEpsbPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderEpsbPropertyChange
    double val = textSliderEpsb.getValue();
    arithmeticFunctionV1c.setThirdArg(val);
    arithmeticFunctionV1d.setThirdArg(val);
    arithmeticFunctionV2.setSecondArg(val);
  }//GEN-LAST:event_textSliderEpsbPropertyChange
  
  private void arithmeticFunctionV1bValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV1bValueChanged
    double val = arithmeticFunctionV1b.getResult();
    allVMux.setInputValues(2, val);
    arithmeticFunctionV1c.setFirstArg(val);
  }//GEN-LAST:event_arithmeticFunctionV1bValueChanged
  
  private void arithmeticFunctionV1aValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV1aValueChanged
    double val = arithmeticFunctionV1a.getResult();
    allVMux.setInputValues(1, val);
  }//GEN-LAST:event_arithmeticFunctionV1aValueChanged
  
  private void textSliderEpsaPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderEpsaPropertyChange
    double val = textSliderEpsa.getValue();
    arithmeticFunctionV1a.setSecondArg(val);
    arithmeticFunctionV1b.setThirdArg(val);
    arithmeticFunctionV1c.setSecondArg(val);
  }//GEN-LAST:event_textSliderEpsaPropertyChange
  
  private void arithmeticFunctionV1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunctionV1ValueChanged
    double val = arithmeticFunctionV1.getResult();
    allVMux.setInputValues(0, val);
    arithmeticFunctionV1a.setFirstArg(val);
  }//GEN-LAST:event_arithmeticFunctionV1ValueChanged
  
  private void textSliderT1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderT1PropertyChange
    double val = textSliderT1.getValue();
    arithmeticFunctionV1.setSecondArg(val);
    arithmeticFunctionV1b.setSecondArg(val);
    arithmeticFunctionV1d.setSecondArg(val);
  }//GEN-LAST:event_textSliderT1PropertyChange
  
  private void textSliderP1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderP1PropertyChange
    double val = textSliderP1.getValue();
    cyclicProcess1.setStartPressure(val);
    arithmeticFunctionV1.setThirdArg(val);
    arithmeticFunctionV1b.setFourthArg(val);
    arithmeticFunctionV1d.setFourthArg(val);
    arithmeticFunctionV3.setThirdArg(val);
    parsedFunctionV3b.singleInputValue(3, val);
  }//GEN-LAST:event_textSliderP1PropertyChange
  
  private void pVScopeMuxValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_pVScopeMuxValueChanged
    xYScope1.setInputVector(pVScopeMux.getOutputVector());
  }//GEN-LAST:event_pVScopeMuxValueChanged
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    pVScopeMux.setInputValues(0, perfectGas1.getVolume());
    pVScopeMux.setInputValues(1, perfectGas1.getPressure());
    tSScopeMux.setInputValues(0, perfectGas1.getEntropy());
    tSScopeMux.setInputValues(1, perfectGas1.getTemperature());
    isexViewMux.setInputValues(0, perfectGas1.getTemperature());
    barViewMux.setInputValues(0, perfectGas1.getInnerEnergy());
    barViewMux.setInputValues(1, perfectGas1.getWork());
    barViewMux.setInputValues(2, perfectGas1.getHeat());
    barViewMux.setInputValues(3, perfectGas1.getTechnicalWork());
    barViewMux.setInputValues(4, perfectGas1.getEnthalpy());
  }//GEN-LAST:event_perfectGas1SourceChanged
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    xYScope1.restart();
    xYScope2.restart();
    cyclicProcess1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    pVScopeMux.trigger();
    tSScopeMux.trigger();
    cyclicProcess1.nextStep();
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.Multiplexer allVMux;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV1;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV1a;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV1b;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV1c;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV1d;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV2;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV3;
  protected physbeans.func.ArithmeticFunction arithmeticFunctionV3a;
  protected physbeans.views.BarView barView1;
  protected physbeans.func.Multiplexer barViewMux;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.phys.CyclicProcess cyclicProcess1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected physbeans.views.IsexView isexView1;
  protected physbeans.func.Multiplexer isexViewMux;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.LabelView labelView1;
  protected physbeans.views.LabelView labelView2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.Multiplexer pVScopeMux;
  protected physbeans.func.ParsedFunction parsedFunctionV3b;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.PhysicsPanel physicsPanel1;
  protected physbeans.func.Multiplexer tSScopeMux;
  protected physbeans.inout.TextSlider textSliderEps;
  protected physbeans.inout.TextSlider textSliderEpsa;
  protected physbeans.inout.TextSlider textSliderEpsb;
  protected physbeans.inout.TextSlider textSliderEpst;
  protected physbeans.inout.TextSlider textSliderP1;
  protected physbeans.inout.TextSlider textSliderQt;
  protected physbeans.inout.TextSlider textSliderT1;
  protected physbeans.inout.TextSlider textSliderT3;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
  protected physbeans.inout.XYScope xYScope2;
  // End of variables declaration//GEN-END:variables
  
}
